unit DBEinstellungsformular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, checklst, Grids, Buttons, 
  ExtCtrls, ComCtrls, FileCtrl, ActnList, 
  Mask, EinstellungsFormular, SubstanzFormular, NStringGridKomponente,
  NEditKomponente, Outline, DirOutln, Menus;

Const DBMAXLINZAHL = 60;

type

  {teinstellung = (paramBlz, paramMesszahl, paramB_rs232, paramP_rs232,
                  paramNullabgleich, paramSpektrGlaetten);}

  TChromEinst = Record
                  ChromBLZ_s,
                  ChromMesszahl_s,
                  ChromNull_s,
                  ChromSpektrGlaettung_s,
                  Liniennamen_s          : String;
                  LinZahl_i              : Integer;
                  EStandardNormLin_s     : String;
                  ChromGlaettungsgrad_i  : Integer;
                End;

  tdatenbankparameter = Record
                          primaersignal_s : String;
                        End;

  TDBEinstForm = class(TForm)
    OK: TBitBtn;
    abbrechen: TBitBtn;
    PageControl: TPageControl;
    DatenbankTabSheet: TTabSheet;
    AllgemeinPanel: TPanel;
    LinTabSheet: TTabSheet;
    RegressionsTabSheet: TTabSheet;
    RegressionsPanel: TPanel;
    IntensOffsetScrollBar: TScrollBar;
    IntensOffsetEdit: TEdit;
    OffsetScrollBar: TScrollBar;
    OffsetEdit: TEdit;
    IntensScrollBar: TScrollBar;
    IntensEdit: TEdit;
    HWBScrollBar: TScrollBar;
    HWBEdit: TEdit;
    SpektrometerTabSheet: TTabSheet;
    InfoPanel: TPanel;
    BlzLabel: TLabel;
    MesszahlLabel: TLabel;
    NullabgleichLabel: TLabel;
    SpGlaettungLabel: TLabel;
    ChromGlaettungLabel: TLabel;
    NullabgleichPanel: TPanel;
    JaRadioButton: TRadioButton;
    NeinRadioButton: TRadioButton;
    SpGlaettungPanel: TPanel;
    SpEinsRadioButton: TRadioButton;
    SpDreiRadioButton: TRadioButton;
    SpFuenfRadioButton: TRadioButton;
    SpAlleRadioButton: TRadioButton;
    ChromGaettungPanel: TPanel;
    DreiRadioButton: TRadioButton;
    FuenfRadioButton: TRadioButton;
    SiebenRadioButton: TRadioButton;
    PrimSignComboBox: TComboBox;
    LinienPanel: TPanel;
    DBSignaleLabel1: TLabel;
    PrimSignalLabel: TLabel;
    ImportBitBtn: TBitBtn;
    EinsRadioButton: TRadioButton;
    SubstanzenTabSheet: TTabSheet;
    Panel1: TPanel;
    LoeschenBitBtn: TBitBtn;
    NeuBitBtn: TBitBtn;
    BearbeitenBitBtn: TBitBtn;
    SortBitBtn: TBitBtn;
    SubstOpenDialog: TOpenDialog;
    OffsetLabel: TLabel;
    OffsetComboBox: TComboBox;
    RegHoehe2Label: TLabel;
    SDLabel: TLabel;
    Label7: TLabel;
    SubstanzenNStringGrid: TNStringGrid;
    LinienNStringGrid: TNStringGrid;
    ChrominfoBitBtn: TBitBtn;
    BlzNEdit: TNEdit;
    MesszahlNEdit: TNEdit;
    HWBLabel: TLabel;
    AufnahmePanel: TPanel;
    Label9: TLabel;
    MinAbwScrollBar: TScrollBar;
    MinAbwEdit: TEdit;
    Label1: TLabel;
    DeformLabel: TLabel;
    DeformScrollBar: TScrollBar;
    RegressionAlgemeinPanel: TPanel;
    Label2: TLabel;
    Label6: TLabel;
    Panel3: TPanel;
    HoeheRadioButton: TRadioButton;
    FlaecheRadioButton: TRadioButton;
    UnabhaengigeNEdit: TNEdit;
    Label8: TLabel;
    Panel2: TPanel;
    IntensCheckBox: TCheckBox;
    IntensOffsetCheckBox: TCheckBox;
    OffsetCheckBox: TCheckBox;
    HWBCheckBox: TCheckBox;
    DeformCheckBox: TCheckBox;
    EStandardNEdit: TNEdit;
    EStandard1Label: TLabel;
    EStandard2Label: TLabel;
    DBNameLabel: TLabel;
    NeueMethodeLabel: TLabel;
    DBNeuEdit: TEdit;
    DBNameComboBox: TComboBox;
    DBLoeschenBitBtn: TBitBtn;
    DBHinzufuegenBitBtn: TBitBtn;
    DBMemo: TMemo;
    Label4: TLabel;
    DBFileListBox: TFileListBox;
    GewichtungPanel: TPanel;
    LinienTrackBar: TTrackBar;
    Label10: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    AbstandLabel: TLabel;
    AbstandsPanel: TPanel;
    AbstandIntensRadioButton: TRadioButton;
    AbstandVerhaeltnisRadioButton: TRadioButton;
    LinienPopupMenu: TPopupMenu;
    LinAusAktEinstMenuItem: TMenuItem;
    LinAusChromMenuItem: TMenuItem;
    EliminierenBitBtn: TBitBtn;
    DelAllBitBtn: TBitBtn;
    GesamtScrollBar: TScrollBar;
    GesamtEdit: TEdit;
    GesamtLabel: TLabel;
    DeformEdit: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure blzEditExit(Sender: TObject);
    procedure MesszahlEditExit(Sender: TObject);
    procedure DBLinLoeschenBitBtnClick(Sender: TObject);
    procedure IntensOffsetScrollBarChange(Sender: TObject);
    procedure OffsetScrollBarChange(Sender: TObject);
    procedure IntensScrollBarChange(Sender: TObject);
    procedure DeformScrollBarChange(Sender: TObject);
    procedure ImportBitBtnClick(Sender: TObject);
    procedure NeuBitBtnClick(Sender: TObject);
    procedure BearbeitenBitBtnClick(Sender: TObject);
    procedure LoeschenBitBtnClick(Sender: TObject);
    procedure SortBitBtnClick(Sender: TObject);
    procedure SubstOpenDialogCanClose(Sender: TObject;
      var CanClose: Boolean);
    procedure ChrominfoBitBtnClick(Sender: TObject);
    procedure MinAbwScrollBarChange(Sender: TObject);
    procedure DBHinzufuegenBitBtnClick(Sender: TObject);
    procedure DBLoeschenBitBtnClick(Sender: TObject);
    procedure DBNameComboBoxChange(Sender: TObject);
    procedure LinienTrackBarChange(Sender: TObject);
    procedure LinienNStringGridClick(Sender: TObject);
    procedure LinAusAktEinstMenuItemClick(
      Sender: TObject);
    procedure LinAusChromMenuItemClick(Sender: TObject);
    procedure EliminierenBitBtnClick(Sender: TObject);
    procedure DelAllBitBtnClick(Sender: TObject);
    procedure HWBScrollBarChange(Sender: TObject);
    procedure PrimSignComboBoxChange(Sender: TObject);
    procedure OffsetComboBoxChange(Sender: TObject);
    procedure GesamtScrollBarChange(Sender: TObject);

  private
    { Private-Deklarationen }

    ChromEinst           : TChromEinst;

    arbeitsverzeichnis_s : String;
    AktDatenbank_s       : String;  //Aktuelle Datenbank

    SortAufsteigend_b    : Boolean; //Sollen die Substanzen aufsteigend sortiert
                                    //werden?

    Procedure blz_mz_pruefen(Var blz_i, messzahl_i : Integer);
    Function  spglaettungsgrad_i : Integer;
    Procedure standardeinstellungen;
    Procedure LinienZuruecksetzen;
    Procedure SubstanzenZuruecksetzen;

    Procedure ChromOptionenEin;
    Procedure ChromOptionenAus;

    Function DatenInDatenbank_b : Boolean;  //Sind Substanzdateien in der Da-
                                            //tenbank

    Procedure ComboBoxFuellen(Var ComboBox : TComboBox;
                                  Offset_b : Boolean);
    Procedure ComboBoxenFuellen;
    Procedure DBNameAktualisieren(AktDBVonPlatte_b : Boolean);
    Function Laden_b                           : Boolean;
    Function Speichern_b(pfad_s : String)      : Boolean;
    Function SubstSpeichern_b(pfad_s : String) : Boolean;
    Procedure SubstanzDateienLoeschen(Von_i, Bis_i : Integer);

    Function EndungsCheck_b(Var FileName : TFileName;
                                endung_s : String) : Boolean;

    Procedure LinAusAktEinstellungen;
    Procedure LinAusChrom;

  public { Public-Deklarationen }

     Function OutDBPfad_s : String;
     //Function OutDBName_s : String;
     Function ShowModal(ChromBLZ_s,
                        ChromMesszahl_s,
                        ChromNull_s,
                        ChromSpektrGlaettung_s,
                        liniennamen_s          : String;
                        LinZahl_i              : Integer;
                        EStandardNormLin_s     : String;
                        ChromGlaettungsGrad_i  : Integer) : Integer; Overload;
     
  end;

var
  DBEinstForm: TDBEinstForm;

implementation

{$R *.DFM}




Procedure tDBEinstForm.blz_mz_pruefen(Var blz_i, messzahl_i : Integer);
Begin
  //Wurden ganze Zahlen eingegeben?
  Try blz_i := StrToInt(BlzNEdit.Text);
  Except blz_i := 100;
  End;
  Try messzahl_i := StrToInt(MesszahlNEdit.Text);
  Except messzahl_i := 1;
  End;
  //Sind die Zahlen zu gro oder klein?
  If blz_i <   1 Then blz_i := 1;
  If blz_i > 650 Then blz_i := 650;
  If messzahl_i <   1 Then messzahl_i :=   1;
  If messzahl_i > 100 Then messzahl_i := 100
End;



Function tDBEinstForm.DatenInDatenbank_b : Boolean;
Begin
  With SubstanzenNStringGrid Do
       Result := (RowCount > 2) Or Not(StrRead_s(1, 1) = '')
End;



Procedure tDBEinstForm.ChromOptionenEin;
Begin
  SpektrometerTabSheet.Enabled := True;
  BlzLabel.Enabled             := True;
  MesszahlLabel.Enabled        := True;
  NullabgleichLabel.Enabled    := True;
  SpGlaettungLabel.Enabled     := True;
  ChromGlaettungLabel.Enabled  := True;
  BlzNEdit.Enabled             := True;
  MesszahlNEdit.Enabled        := True;
  JaRadioButton.Enabled        := True;
  NeinRadioButton.Enabled      := True;
  SpEinsRadioButton.Enabled    := True;
  SpDreiRadioButton.Enabled    := True;
  SpFuenfRadioButton.Enabled   := True;
  SpAlleRadioButton.Enabled    := True;
  EinsRadioButton.Enabled      := True;
  DreiRadioButton.Enabled      := True;
  FuenfRadioButton.Enabled     := True;
  SiebenRadioButton.Enabled    := True;
  EStandardNEdit.Enabled       := True;
  EStandard1Label.Enabled      := True;
  EStandard2Label.Enabled      := True;
  LinienNStringGrid.Options    := LinienNStringGrid.Options + [goEditing]
End;



Procedure tDBEinstForm.ChromOptionenAus;
Begin
  SpektrometerTabSheet.Enabled := False;
  BlzLabel.Enabled             := False;
  MesszahlLabel.Enabled        := False;
  NullabgleichLabel.Enabled    := False;
  SpGlaettungLabel.Enabled     := False;
  ChromGlaettungLabel.Enabled  := False;
  BlzNEdit.Enabled             := False;
  MesszahlNEdit.Enabled        := False;
  JaRadioButton.Enabled        := False;
  NeinRadioButton.Enabled      := False;
  SpEinsRadioButton.Enabled    := False;
  SpDreiRadioButton.Enabled    := False;
  SpFuenfRadioButton.Enabled   := False;
  SpAlleRadioButton.Enabled    := False;
  EinsRadioButton.Enabled      := False;
  DreiRadioButton.Enabled      := False;
  FuenfRadioButton.Enabled     := False;
  SiebenRadioButton.Enabled    := False;
  EStandardNEdit.Enabled       := False;
  EStandard1Label.Enabled      := False;
  EStandard2Label.Enabled      := False;
  LinienNStringGrid.Options    := LinienNStringGrid.Options - [goEditing]
End;



Function tDBEinstForm.ShowModal(ChromBLZ_s,
                                ChromMesszahl_s,
                                ChromNull_s,
                                ChromSpektrGlaettung_s,
                                Liniennamen_s           : String;
                                LinZahl_i               : Integer;
                                EStandardNormLin_s      : String;
                                ChromGlaettungsGrad_i   : Integer) : Integer;
Begin
  ChromEinst.ChromBLZ_s              := ChromBLZ_s;
  ChromEinst.ChromMesszahl_s         := ChromMesszahl_s;
  ChromEinst.ChromNull_s             := ChromNull_s;
  ChromEinst.ChromSpektrGlaettung_s  := ChromSpektrGlaettung_s;
  ChromEinst.ChromGlaettungsGrad_i   := ChromGlaettungsGrad_i;
  ChromEinst.Liniennamen_s           := Liniennamen_s;
  ChromEinst.LinZahl_i               := LinZahl_i; 
  ChromEinst.EStandardNormLin_s      := EStandardNormLin_s;
  Result := ShowModal;
  If Result = mrOk Then
     If Not(AktDatenbank_s = '') Then speichern_b(  Arbeitsverzeichnis_s
                                                  + '\' + AktDatenbank_s
                                                  + '.SDB');
End;



Function tDBEinstForm.OutDBPfad_s : String;
Begin
  If AktDatenbank_s = '' Then Result := ''
                         Else Result :=   Arbeitsverzeichnis_s + '\'
                                        + AktDatenbank_s + '.SDB'
End;



Function tDBEinstForm.spglaettungsgrad_i : Integer;
Begin
  If SpEinsRadioButton.Checked Then Result := 1
     Else If SpDreiRadioButton.Checked Then Result := 3
          Else If SpFuenfRadioButton.Checked Then Result := 5
          Else Result := 7
End;



Procedure tDBEinstForm.ComboBoxFuellen(Var ComboBox : TComboBox;
                                           Offset_b : Boolean);

Var i, Index_i : Integer;

Begin
  With ComboBox Do
       Begin
         Index_i := ItemIndex;
         Clear;
         For i := 1 To Pred(LinienNStringGrid.RowCount) Do
             If Not(LinienNStringGrid.StrRead_s(1, i) = '') Then
                Items.Add(LinienNStringGrid.StrRead_s(1, i));
         If (Index_i >= Items.Count) Or (Index_i = -1) Then
            Begin
              If Offset_b Then ItemIndex := 1
                          Else ItemIndex := 0
            End
            Else ItemIndex := Index_i
       End;
End;



Procedure tDBEinstForm.ComboBoxenFuellen;
Begin
  ComboBoxFuellen(PrimSignComboBox, False);
  ComboBoxFuellen(OffsetComboBox, True);
  If PrimSignComboBox.ItemIndex = OffsetComboBox.ItemIndex Then
     Begin
       PrimSignComboBox.ItemIndex := 0;
       OffsetComboBox.ItemIndex   := 1
     End;
End;



Procedure TDBEinstForm.LinienZuruecksetzen;

Var z : Integer;

Begin
  With LinienNStringGrid Do
       For z := 1 To Pred(RowCount) Do
           Begin
             StrWrite(1, z, '');
             StrWrite(2, z, '0')
           End
End;



Procedure TDBEinstForm.SubstanzenZuruecksetzen;
Begin
  With SubstanzenNStringGrid Do
       Begin
         RowCount := 2;
         ClearRow(2)
       End;
  ChromOptionenEin
End;



Procedure TDBEinstForm.standardeinstellungen;
Begin
  BlzNEdit.text                  := '100';
  MesszahlNEdit.text             := '1';
  NeinRadioButton.Checked        := True;
  JaRadioButton.Checked          := False;
  EinsRadioButton.Checked        := True;
  DreiRadioButton.Checked        := False;
  FuenfRadioButton.Checked       := False;
  SiebenRadioButton.Checked      := False;
  SpEinsRadioButton.Checked      := True;
  SpDreiRadioButton.Checked      := False;
  SpFuenfRadioButton.Checked     := False;
  SpAlleRadioButton.Checked      := False;
  IntensScrollBar.Position       := 0;
  IntensOffsetScrollBar.Position := 0;
  OffsetScrollBar.Position       := 0;
  HWBScrollBar.Position          := 0;
  DeformScrollBar.Position       := 0;
  GesamtScrollBar.Position       := 100;
  IntensEdit.Text                := '';
  IntensOffsetEdit.Text          := '';
  OffsetEdit.Text                := '';
  HWBEdit.Text                   := '';
  DeformEdit.Text                := '';
  SubstanzenZuruecksetzen;
  LinienZuruecksetzen;
End;



Function tDBEinstForm.Laden_b : Boolean;

Var datei_txt         : TextFile;
    puffer_s          : String;
    i, j, glaettung_i : Integer;

Begin
  LinienZuruecksetzen;

  If AktDatenbank_s = '' Then
     Begin
       Result := False;
       Exit
     End;

  Try AssignFile(datei_txt,   Arbeitsverzeichnis_s
                            + '\'
                            + AktDatenbank_s + '.SDB');
      Reset(datei_txt);
      Result := True;
  Except Result := False;
  End;
  Try DBMemo.Lines.Clear;
      For i := 0 To 20 Do
          Begin
            ReadLn(datei_txt, puffer_s);
            DBMemo.Lines.Add(puffer_s);
          End;
      i := DBMemo.Lines.Count;
      Dec(i);
      While (DBMemo.Lines.Strings[i] = '') And (i > 0) Do Dec(i);
      For j := 1 To Pred(DBMemo.Lines.Count) - i Do
          DBMemo.Lines.Delete(Pred(DBMemo.Lines.Count));

      ReadLn(datei_txt, puffer_s);
      BlzNEdit.Text := puffer_s;
      ReadLn(datei_txt, puffer_s);
      MesszahlNEdit.Text := puffer_s;
      ReadLn(datei_txt, puffer_s);
      JaRadioButton.Checked := (puffer_s = 'TRUE');
      If Not(JaRadioButton.Checked) Then NeinRadioButton.Checked := True;
      ReadLn(datei_txt, glaettung_i);
      EinsRadioButton.Checked   := False;
      DreiRadioButton.Checked   := False;
      FuenfRadioButton.Checked  := False;
      SiebenRadioButton.Checked := False;
      Case glaettung_i Of
           1 : EinsRadioButton.Checked   := True;
           3 : DreiRadioButton.Checked   := True;
           5 : FuenfRadioButton.Checked  := True;
           7 : SiebenRadioButton.Checked := True
         End;
      ReadLn(datei_txt, glaettung_i);
      SpEinsRadioButton.Checked  := False;
      SpDreiRadioButton.Checked  := False;
      SpFuenfRadioButton.Checked := False;
      SpAlleRadioButton.Checked  := False;
      Case glaettung_i Of
           1 : SpEinsRadioButton.Checked  := True;
           3 : SpDreiRadioButton.Checked  := True;
           5 : SpFuenfRadioButton.Checked := True;
           7 : SpAlleRadioButton.Checked  := True
         End;
      ReadLn(datei_txt, puffer_s);
      EStandardNEdit.Text := puffer_s;
      With LinienNStringGrid Do
           Begin
             For i := 1 To Pred(RowCount) Do
                 Begin
                   ReadLn(datei_txt, puffer_s);
                   StrWrite(1, i, puffer_s)
                 End;
             For i := 1 To Pred(RowCount) Do
                 Begin
                   ReadLn(datei_txt, puffer_s);
                   If puffer_s = 'Ja'   Then puffer_s := '100';
                   If puffer_s = 'Nein' Then puffer_s := '0';
                   StrWrite(2, i, puffer_s)
                 End;
             //j := 0;
           End;
      ReadLn(datei_txt, puffer_s);
      If puffer_s = 'TRUE' Then
         Begin
           AbstandIntensRadioButton.Checked      := True;
           AbstandVerhaeltnisRadioButton.Checked := False;
         End
         Else
         Begin
           AbstandIntensRadioButton.Checked      := False;
           AbstandVerhaeltnisRadioButton.Checked := True;
         End;
      ComboBoxFuellen(PrimSignComboBox, False);
      ComboBoxFuellen(OffsetComboBox, True);
      ReadLn(datei_txt, puffer_s);
      PrimSignComboBox.ItemIndex := StrToInt(puffer_s);
      ReadLn(datei_txt, puffer_s);
      OffsetComboBox.ItemIndex := StrToInt(puffer_s);
      ReadLn(datei_txt, puffer_s);
      If puffer_s = 'TRUE' Then
         Begin
           HoeheRadioButton.Checked   := True;
           FlaecheRadioButton.Checked := False;
         End
         Else
         Begin
           HoeheRadioButton.Checked   := False;
           FlaecheRadioButton.Checked := True;
         End;
      ReadLn(datei_txt, puffer_s);
      IntensScrollBar.Position := StrToInt(puffer_s);
      ReadLn(datei_txt, puffer_s);
      IntensOffsetScrollBar.Position := StrToInt(puffer_s);
      ReadLn(datei_txt, puffer_s);
      OffsetScrollBar.Position := StrToInt(puffer_s);
      ReadLn(datei_txt, puffer_s);
      HWBScrollBar.Position := StrToInt(puffer_s);
      ReadLn(datei_txt, puffer_s);
      DeformScrollBar.Position := StrToInt(puffer_s);
      ReadLn(datei_txt, puffer_s);
      UnabhaengigeNEdit.Text := Puffer_s;
      ReadLn(datei_txt, puffer_s);
      IntensCheckBox      .Checked := (puffer_s[1] = '0');
      IntensOffsetCheckBox.Checked := (puffer_s[2] = '0');
      OffsetCheckBox      .Checked := (puffer_s[3] = '0');
      HWBCheckBox         .Checked := (puffer_s[4] = '0');
      DeformCheckBox      .Checked := (puffer_s[5] = '0');
      If Length(puffer_s) = 7 Then puffer_s := puffer_s[6] + puffer_s[7]
         Else If Length(puffer_s) = 6 Then puffer_s := puffer_s[6]
              Else puffer_s := '100';
      GesamtScrollBar.Position := StrToInt(puffer_s);
      ReadLn(datei_txt, puffer_s);
      MinAbwScrollBar.Position := StrToInt(puffer_s);
      SubstanzenZuruecksetzen;
      i := 1;
      While Not(EOF(datei_txt)) Do
            With SubstanzenNStringGrid Do
                 Begin
                   If Not(i = 1) Then RowCount := RowCount + 1;
                   IntWrite(0, i, i);
                   ReadLn(datei_txt, puffer_s);
                   StrWrite(1, i, puffer_s);
                   ReadLn(datei_txt, puffer_s);
                   StrWrite(2, i, puffer_s);
                   Inc(i)
                  End;
      Result := True;
  Except Result:= False
  End;
  Try CloseFile(datei_txt);
       Except Result := False
       End;
  IF Result Then
     Begin
       If DatenInDatenbank_b Then ChromOptionenAus
          Else ChromOptionenEin
     End
     Else
     Begin
       Application.MessageBox('Fehler beim Laden der Datenbank!',
                              'Fehlermeldung', Mb_Ok + MB_ICONSTOP);
       standardeinstellungen
     End;

End;



Function tDBEinstForm.Speichern_b(pfad_s : String) : Boolean;

Var datei_txt : TextFile;
    i         : Integer;
    Code_i    : Integer; //Nachtrgliches Anfgen eines weiteren Parameters
                         //(2 Werte werden in eine Zahl gespeichert)

Begin
  Try AssignFile(datei_txt, pfad_s);
      Rewrite(datei_txt);
      Result := True;
  Except Result := False;
  End;
  If Result Then
     Begin
       Try With DBMemo.Lines Do
                For i := 0 To 20 Do
                    If i < Count Then WriteLn(datei_txt, Strings[i])
                                 Else WriteLn(datei_txt);

           WriteLn(datei_txt, BlzNEdit.StrRead_s);
           WriteLn(datei_txt, MesszahlNEdit.StrRead_s);
           WriteLn(datei_txt, JaRadioButton.Checked);
           If EinsRadioButton.Checked Then WriteLn(datei_txt, '1')
              Else
              If DreiRadioButton.Checked Then WriteLn(datei_txt, '3')
                 Else
                 If FuenfRadioButton.Checked Then WriteLn(datei_txt, '5')
                    Else WriteLn(datei_txt, '7');
           WriteLn(datei_txt, spglaettungsgrad_i);
           WriteLn(datei_txt, EStandardNEdit.Text);
           With LinienNStringGrid Do
                For i := 1 To Pred(RowCount) Do
                    WriteLn(datei_txt, StrRead_s(1, i));
           If AnsiLowerCase(Copy(pfad_s, Length(pfad_s) - 2, 3)) = 'sdb' Then
              Begin
                With LinienNStringGrid Do
                     For i := 1 To Pred(RowCount) Do
                         WriteLn(datei_txt, StrRead_s(2, i));
                WriteLn(datei_txt, AbstandIntensRadioButton.Checked);
                WriteLn(datei_txt, PrimSignComboBox.ItemIndex);
                WriteLn(datei_txt, OffsetComboBox.ItemIndex);
                WriteLn(datei_txt, HoeheRadioButton.Checked);
                WriteLn(datei_txt, IntensScrollBar.Position);
                WriteLn(datei_txt, IntensOffsetScrollBar.Position);
                WriteLn(datei_txt, OffsetScrollBar.Position);
                WriteLn(datei_txt, HWBScrollBar.Position);
                WriteLn(datei_txt, DeformScrollBar.Position);
                WriteLn(datei_txt, UnabhaengigeNEdit.StrRead_s);
                If IntensCheckBox      .Checked Then Write(datei_txt, '0')
                                                Else Write(datei_txt, '1');
                If IntensOffsetCheckBox.Checked Then Write(datei_txt, '0')
                                                Else Write(datei_txt, '1');
                If OffsetCheckBox      .Checked Then Write(datei_txt, '0')
                                                Else Write(datei_txt, '1');
                If HWBCheckBox         .Checked Then Write(datei_txt, '0')
                                                Else Write(datei_txt, '1');
                If DeformCheckBox      .Checked Then Write(datei_txt, '0')
                                                Else Write(datei_txt, '1');
                Write(datei_txt, GesamtScrollBar.Position);
                WriteLn(datei_txt);
                WriteLn(datei_txt, MinAbwScrollBar.Position);
                With SubstanzenNStringGrid Do
                     For i := 1 To Pred(RowCount) Do
                         Begin
                           WriteLn(datei_txt, StrRead_s(1, i));
                           WriteLn(datei_txt, StrRead_s(2, i))
                         End
              End;
       Except Result := False;
       End;
       Try CloseFile(datei_txt);
       Except Result := False
       End
     End;
  If NOT(Result) Then
     Application.MessageBox('Fehler beim Speichern der Einstellungen!',
                            'Fehlermeldung', Mb_Ok + MB_ICONSTOP)
End;



Procedure TDBEinstForm.DBNameAktualisieren(AktDBVonPlatte_b : Boolean);

Var i        : Integer;
    puffer_s : String;

Function GewaehltenEintragLaden_b : Boolean;

Var puffer_s  : String;
    i         : Integer;
    datei_txt : TextFile;

Begin
  Try AssignFile(datei_txt, Arbeitsverzeichnis_s + '\ADBName.spg');
      Reset(datei_txt);
      Result := True;
  Except Result := False;
  End;
  Try Read(datei_txt, AktDatenbank_s);
      Except Result := False
      End;
  Try CloseFile(datei_txt);
      Except Result := False
      End;
  IF Not(Result) Then
     Begin
       Application.MessageBox('Fehler beim Laden der Datenbank! ' +
                              'Probleme beim Laden von "ADBName.SPG"!',
                              'Fehlermeldung', Mb_Ok + MB_ICONSTOP);
       AktDatenbank_s := ''
     End
End;

Function GewaehltenEintragSpeichern_b : Boolean;

Var Datei_txt : TextFile;

Begin
  Try AssignFile(datei_txt, Arbeitsverzeichnis_s + '\ADBName.spg');
      Rewrite(datei_txt);
      Result := True;
  Except Result := False;
  End;
  Write(datei_txt, DBNameComboBox.Items.Strings[DBNameComboBox.ItemIndex]);
  Try CloseFile(datei_txt);
       Except Result := False
       End;
  IF Not(Result) Then
     Application.MessageBox('Fehler beim Speichern der Datenbank! ' +
                            'Probleme beim Speichern von "ADBName.SPG"!',
                            'Fehlermeldung', Mb_Ok + MB_ICONSTOP)
End;

Begin
  If AktDBVonPlatte_b Then GewaehltenEintragLaden_b;
  With DBFileListBox Do
       Begin
         Update;
         DBNameComboBox.Clear;
         DBNameComboBox.ItemIndex := -1;
         For i := 0 To Pred(Items.Count) Do
             Begin
               puffer_s := Items.Strings[i];
               //Endung wegnehemen
               If Copy(puffer_s, Length(puffer_s) - 3, 4) = '.SDB' Then
                  puffer_s := Copy(puffer_s, 1, Length(puffer_s) - 4);
               //Eintrag hinzufgen
               DBNameComboBox.Items.Add(puffer_s);
             End;
         For i := 0 To Pred(DBNameComboBox.Items.Count) Do
             If DBNameComboBox.Items.Strings[i] = AktDatenbank_s Then
                DBNameComboBox.ItemIndex := i;
         If DBNameComboBox.ItemIndex = -1 Then AktDatenbank_s := ''
       End;
  GewaehltenEintragSpeichern_b;
End;




procedure TDBEinstForm.FormCreate(Sender: TObject);

Var i : Integer;

begin
  With LinienNStringGrid Do
       Begin
         RowCount := Succ(DBMAXLINZAHL);
         For i := 1 To Pred(RowCount) Do IntWrite(0, i, i);
         StrWrite(0, 0, 'Nr.');
         StrWrite(1, 0, 'Linie');
         StrWrite(2, 0, 'Gewichtung');
       End;
  With SubstanzenNStringGrid Do
       Begin
         ColWidths[0] := 35;
         ColWidths[1] := 200;
         ColWidths[2] := 1000;
         StrWrite(0, 0, 'Nr.');
         StrWrite(1, 0, 'Substanz');
         StrWrite(2, 0, 'Pfad der Informationsdatei');
       End;
  SortAufsteigend_b := True;
  GetDir(0, arbeitsverzeichnis_s);
  DBFileListBox.Mask := arbeitsverzeichnis_s + '\*.SDB';
  DBNameAktualisieren(True);
  laden_b;
  SubstOpenDialog.InitialDir := arbeitsverzeichnis_s;
  With LinienNStringGrid Do
       Begin
         Row := 1;
         LinienTrackBar.Position := StrToInt(StrRead_s(2, Row))
       End
end;




procedure TDBEinstForm.blzEditExit(Sender: TObject);

Var blz_i, messzahl_i : Integer;

Begin
  blz_mz_pruefen(blz_i, messzahl_i);
  BlzNEdit.Text := IntToStr(blz_i)
end;



procedure TDBEinstForm.MesszahlEditExit(Sender: TObject);

Var blz_i, messzahl_i : Integer;

begin
  blz_mz_pruefen(blz_i, messzahl_i);
  MesszahlNEdit.Text := IntToStr(messzahl_i)
end;



procedure TDBEinstForm.DBLinLoeschenBitBtnClick(Sender: TObject);
begin
  With LinienNStringGrid Do
       Begin
         ClearRow(Row);
         PrimSignComboBox.Items.Delete(Pred(Row))
        End;
end;



procedure TDBEinstForm.IntensOffsetScrollBarChange(Sender: TObject);
begin
  IntensOffsetEdit.Text := IntToStr(IntensOffsetScrollBar.Position) + '%'
end;



procedure TDBEinstForm.IntensScrollBarChange(Sender: TObject);
begin
  IntensEdit.Text := IntToStr(IntensScrollBar.Position) + '%'
end;



procedure TDBEinstForm.OffsetScrollBarChange(Sender: TObject);
begin
  OffsetEdit.Text := IntToStr(OffsetScrollBar.Position) + '%'
end;



procedure TDBEinstForm.HWBScrollBarChange(Sender: TObject);
begin
  HWBEdit.Text := IntToStr(HWBScrollBar.Position) + '%'
end;



procedure TDBEinstForm.DeformScrollBarChange(Sender: TObject);
begin
  DeformEdit.Text := IntToStr(DeformScrollBar.Position) + '%'
end;


procedure TDBEinstForm.GesamtScrollBarChange(Sender: TObject);
begin
  GesamtEdit.Text := FloatToStr(GesamtScrollBar.Position) + '%'
end;



procedure TDBEinstForm.MinAbwScrollBarChange(Sender: TObject);
begin
  MinAbwEdit.Text := FloatToStr(MinAbwScrollBar.Position /10) + '%'
end;



Procedure TDBEinstForm.LinAusAktEinstellungen;

Var i : Integer;

Begin
  If EinstForm.OutLinBez_s(2) = '' Then  //Sind weniger als 2 Linien vorhanden?
     Begin
       MessageBeep(MB_ICONSTOP);
       MessageDlg('Zu wenige Linien/Banden! => Linieneinstellungen nicht ' +
                  'bernommen', mtError, [mbOK], 0                          )
     End
     Else
     Begin
       LinienZuruecksetzen;
       With LinienNStringGrid Do
            For i := 1 To Pred(RowCount) Do
                StrWrite(1, i, EinstForm.OutLinBez_s(i));
       ComboBoxenFuellen
     End;
End;



procedure TDBEinstForm.ImportBitBtnClick(Sender: TObject);

Var i : Integer;

Begin
  BlzNEdit.text      := EinstForm.OutEinst_s(paramBlz);
  MesszahlNEdit.text := EinstForm.OutEinst_s(paramMesszahl);
  If EinstForm.OutEinst_s(paramNullabgleich) = 'Ja' Then
     Begin
       JaRadioButton.Checked   := True;
       NeinRadioButton.Checked := False
     End
     Else
     Begin
       JaRadioButton.Checked   := False;
       NeinRadioButton.Checked := True
      End;

  SpEinsRadioButton.Checked  := False;
  SpDreiRadioButton.Checked  := False;
  SpFuenfRadioButton.Checked := False;
  SpAlleRadioButton.Checked  := False;
  If EinstForm.OutEinst_s(paramSpektrGlaetten) = 'Nein' Then
     SpEinsRadioButton.Checked := True
     Else
     If EinstForm.OutEinst_s(paramSpektrGlaetten) = 'Ja, ber 3 Punkte' Then
        SpDreiRadioButton.Checked := True
        Else
        If EinstForm.OutEinst_s(paramSpektrGlaetten) = 'Ja, ber 5 Punkte' Then
           SpFuenfRadioButton.Checked := True
           Else SPAlleRadioButton.Checked := True;

  EinsRadioButton.Checked   := False;
  DreiRadioButton.Checked   := False;
  FuenfRadioButton.Checked  := False;
  SiebenRadioButton.Checked := False;
  Case EinstForm.OutChromGlaettung_i Of
       3 : DreiRadioButton.Checked   := True;
       5 : FuenfRadioButton.Checked  := True;
       7 : SiebenRadioButton.Checked := True;
     End;
  EStandardNEdit.Text := EinstForm.OutEinst_s(paramEStandardDLine);

  LinAusAktEinstellungen;
End;



Function TDBEinstForm.SubstSpeichern_b(pfad_s : String) : Boolean;

Var datenbank_txt, substanz_txt : TextFile;
    datenbank_s, substanz_s     : String;
    i                           : Integer;

Begin
  //Um die Parameter, unter welchen die Substanz gemessen wurde mit denen zu
  //vergleichen, die fr diese Datenbank vorgegeben wurden, muss die Datenbank
  //natrlich abgespeichert sein. Ansonsten schlgt der Dateivergleich fehl.
  If Not(AktDatenbank_s = '') Then speichern_b(  Arbeitsverzeichnis_s
                                               + '\' + AktDatenbank_s
                                               + '.SDB');

  If FileExists(pfad_s) Then //Dann mssen Substanz- und Datenbankdatei
     Begin                   //verglichen werden, damit man wei, ob die
       //Daten zur Substanz auch zur Datenbank passen oder die Signale bei
       //anderen Betriebsparametern des Spektrometers aufgenommen wurden
       Result := True;
       Try AssignFile(datenbank_txt,   Arbeitsverzeichnis_s
                                     + '\'
                                     + AktDatenbank_s + '.SDB');
           Reset(datenbank_txt);
           AssignFile(substanz_txt, pfad_s);
           Reset(substanz_txt);
       Except Result := False
       End;
       Try For i := 0 To 20 Do
               Begin
                 ReadLn(datenbank_txt, datenbank_s);
                 ReadLn(substanz_txt, substanz_s);
               End;
           While Not(EOF(substanz_txt)) Do
                 Begin
                   ReadLn(datenbank_txt, datenbank_s);
                   ReadLn(substanz_txt, substanz_s);
                   If Not(datenbank_s = substanz_s) Then Result := False
                 End;
       Except Result := False
       End;
       Try CloseFile(substanz_txt);
           CloseFile(datenbank_txt);
       Except Result := False
       End;
       If Not(Result) Then
          Application.MessageBox('Substanz passt nicht in die Datenbank ' +
                                 'oder Dateifehler!',
                                 'Fehlermeldung', Mb_Ok + MB_ICONSTOP)
     End
     Else Result := speichern_b(pfad_s)
End;



procedure TDBEinstForm.NeuBitBtnClick(Sender: TObject);

Var name_s, pfad_s : String;

begin
  name_s := '';
  pfad_s := '';
  SubstanzForm.ModalAnzeigen(name_s, pfad_s, SubstOpenDialog);
  If Not((name_s = '') Or (pfad_s = '')) And SubstSpeichern_b(pfad_s) Then
     With SubstanzenNStringGrid Do
          Begin
            If Not((RowCount = 2) And (StrRead_s(1, 1) = '')) Then
               RowCount := RowCount + 1;
            StrWrite(1, Pred(RowCount), name_s);
            StrWrite(2, Pred(RowCount), pfad_s);
          End;
end;



procedure TDBEinstForm.BearbeitenBitBtnClick(Sender: TObject);

Var name_s, pfad_s : String;

begin
  With SubstanzenNStringGrid Do
       Begin
         name_s := StrRead_s(1, Row);
         pfad_s := StrRead_s(2, Row);
         SubstanzForm.ModalAnzeigen(name_s, pfad_s, SubstOpenDialog);
         If Not((name_s='') Or (pfad_s='')) And SubstSpeichern_b(pfad_s) Then
            Begin
              StrWrite(1, Row, name_s);
              StrWrite(2, Row, pfad_s);
            End
       End
end;



procedure TDBEinstForm.LoeschenBitBtnClick(Sender: TObject);
begin
  With SubstanzenNStringGrid Do
       Begin
         ClearRow(Row);
         If Not(RowCount = 2) Then RowCount := RowCount - 1
       End
end;



Function TDBEinstForm.EndungsCheck_b(Var FileName : TFileName;
                                         endung_s : String) : Boolean;

Var i : Integer;

Begin
  For i := Length(FileName) - 2 To Length(FileName) Do
           FileName[i] := UpCase(FileName[i]);
  If Copy(FileName, Length(FileName) - 3, 4) = '.' + endung_s Then
     Result := True
     Else
     Begin
       If FileExists(FileName) Then
          Begin
            Result := False;
            Application.MessageBox(PChar('Die Dateiendung muss ".' + endung_s +
                                   '" lauten!'),
                                   'Fehlermeldung', Mb_Ok + MB_ICONSTOP)
          End
          Else
          Begin
            FileName := FileName + '.' + endung_s;
            Result   := True
          End;
     End
End;



procedure TDBEinstForm.SortBitBtnClick(Sender: TObject);

Var i : Integer;

begin
  With SubstanzenNStringGrid Do
       Begin
         SubstanzenNStringGrid.SortRows(1, SortAufsteigend_b);
         For i := 1 To Pred(RowCount) Do Cells[0, i] := IntToStr(i)
       End;
  SortAufsteigend_b := Not(SortAufsteigend_b)
end;



procedure TDBEinstForm.SubstOpenDialogCanClose(Sender: TObject;
  var CanClose: Boolean);

Var CFileName : TFileName;

begin
   With SubstOpenDialog Do
        Begin
          CFileName := FileName;
          CanClose := EndungsCheck_b(CFileName, 'SSI');
          FileName := CFileName
        End;
end;



Procedure TDBEinstForm.LinAusChrom;

Const TRENNZEICHEN = ';';

Var zeile_i, i : Integer;
    puffer_s   : String;

Begin
  If ChromEinst.LinZahl_i >= 2 Then
     Begin
       LinienZuruecksetzen;
       Zeile_i := 1;
       puffer_s := '';
       For i := 1 To Length(ChromEinst.LinienNamen_s) Do
           If ChromEinst.Liniennamen_s[i] = TRENNZEICHEN Then
              Begin
                LinienNStringGrid.StrWrite(1, Zeile_i, puffer_s);
                puffer_s := '';
                Inc(zeile_i)
              End
              Else puffer_s := puffer_s + ChromEinst.Liniennamen_s[i];
       LinienNStringGrid.StrWrite(1, Zeile_i, puffer_s);
       ComboBoxenFuellen;
     End
     Else
     Begin
       MessageBeep(MB_ICONSTOP);
       MessageDlg('Zu wenige Linien/Banden! => Linieneinstellungen nicht ' +
                  'bernommen', mtError, [mbOK], 0                          );
     End;
End;



procedure TDBEinstForm.ChrominfoBitBtnClick(Sender: TObject);
begin
  BlzNEdit.text      := ChromEinst.ChromBLZ_s;
  MesszahlNEdit.text := ChromEinst.ChromMesszahl_s;
  If ChromEinst.ChromNull_s = 'Ja' Then
     Begin
       JaRadioButton.Checked   := True;
       NeinRadioButton.Checked := False
     End
     Else
     Begin
       JaRadioButton.Checked   := False;
       NeinRadioButton.Checked := True
      End;

  SpEinsRadioButton.Checked  := False;
  SpDreiRadioButton.Checked  := False;
  SpFuenfRadioButton.Checked := False;
  SpAlleRadioButton.Checked  := False;
  If ChromEinst.ChromSpektrGlaettung_s = 'Nein' Then
     SpEinsRadioButton.Checked := True
     Else
     If ChromEinst.ChromSpektrGlaettung_s = 'Ja, ber 3 Punkte' Then
        SpDreiRadioButton.Checked := True
        Else
        If ChromEinst.ChromSpektrGlaettung_s  = 'Ja, ber 5 Punkte' Then
           SpFuenfRadioButton.Checked := True
           Else SPAlleRadioButton.Checked := True;

  EinsRadioButton.Checked   := False;
  DreiRadioButton.Checked   := False;
  FuenfRadioButton.Checked  := False;
  SiebenRadioButton.Checked := False;
  Case ChromEinst.ChromGlaettungsgrad_i Of
       1 : EinsRadioButton.Checked   := True;
       3 : DreiRadioButton.Checked   := True;
       5 : FuenfRadioButton.Checked  := True;
       7 : SiebenRadioButton.Checked := True;
     End;
  EStandardNEdit.Text := ChromEinst.EStandardNormLin_s;

  LinAusChrom;
End;



procedure TDBEinstForm.DBHinzufuegenBitBtnClick(Sender: TObject);
begin
  If ((AktDatenbank_s = '') OR Speichern_b(  ArbeitsVerzeichnis_s
                                           + '\' + AktDatenbank_s
                                           + '.SDB')             )     And
     Speichern_b(ArbeitsVerzeichnis_s + '\' + DBNeuEdit.Text + '.SDB') Then
     AktDatenbank_s := DBNeuEdit.Text;
  DBNameAktualisieren(False);
end;




procedure TDBEinstForm.DBLoeschenBitBtnClick(Sender: TObject);
begin
  MessageBeep(MB_ICONEXCLAMATION);
  If MessageDlg('Die MethodeDatenbank wird entgltig gelscht!',
                mtWarning, mbOKCancel, 0                        ) = mrOK Then
     If DeleteFile(ArbeitsVerzeichnis_s + '\' + AktDatenbank_s + '.SDB') Then
        DBNameAktualisieren(False)
        Else
        Begin
          MessageBeep(MB_ICONSTOP);
          MessageDlg('Die Datenbank konnte nicht entfernt werden!',
                     mtError, [mbCancel], 0                       )
        End;
end;



procedure TDBEinstForm.DBNameComboBoxChange(Sender: TObject);
begin
  If Not(AktDatenbank_s = '') Then
     Speichern_b(Arbeitsverzeichnis_s + '\' + AktDatenbank_s + '.SDB');
  AktDatenbank_s := DBNameComboBox.Text;
  If Not(laden_b) Then AktDatenbank_s := '';
  DBNameAktualisieren(False)
end;



procedure TDBEinstForm.LinienTrackBarChange(Sender: TObject);
begin
  With LinienNStringGrid Do
       StrWrite(2, Row, IntToStr(LinienTrackBar.Position))
end;



procedure TDBEinstForm.LinienNStringGridClick(Sender: TObject);
begin
  With LinienNStringGrid Do
       LinienTrackBar.Position := StrToInt(StrRead_s(2, Row))
end;




procedure TDBEinstForm.LinAusAktEinstMenuItemClick(
  Sender: TObject);
begin
  LinAusAktEinstellungen
end;




procedure TDBEinstForm.LinAusChromMenuItemClick(
  Sender: TObject);
begin
  LinAusChrom
end;



Procedure TDBEinstForm.SubstanzDateienLoeschen(Von_i, Bis_i : Integer);

Var DelOk_b  : Boolean;
    i        : Integer;
    FileName : TFileName;

Begin
   With SubstanzenNStringGrid Do
        Begin
          DelOK_b := True;
          For i := von_i To bis_i Do
              Begin
                FileName := StrRead_s(2, i);
                If Not(DeleteFile(FileName)) Then DelOk_b := False;
                FileName[Length(FileName)] := 'D';
                If Not(DeleteFile(FileName)) Then DelOk_b := False;
              End;
          If Not(DelOk_b) Then
             Begin
               MessageBeep(MB_ICONSTOP);
               MessageDlg(  'Die Dateien konnten nicht oder nur unvollstndig '
                          + 'gelscht werden!',
                          mtError, [mbOK], 0)
             End;
        End;
End;




procedure TDBEinstForm.EliminierenBitBtnClick(Sender: TObject);

Var FileName : TFileName;
    DelOk_b  : Boolean;

begin
  MessageBeep(MB_ICONEXCLAMATION);
  If MessageDlg(  'Gefahr von unwiederbringlichen Datenverlust!'
                + ' Die Substanzdateien wirklich entfernen?',
                mtWarning, [mbOK, mbCancel], 0)                  = mrOK Then
     Begin
       With SubstanzenNStringGrid Do
            Begin
              SubstanzDateienLoeschen(Row, Row);
              ClearRow(Row);
              If Not(RowCount = 2) Then RowCount := RowCount - 1
            End
     End
end;



procedure TDBEinstForm.DelAllBitBtnClick(Sender: TObject);

Var i       : Integer;
    DelOK_b : Boolean;

begin
  MessageBeep(MB_ICONQUESTION);
  If MessageDlg('Wirklich alle Substanzen lschen',
                mtConfirmation, [mbOK, mbCancel], 0) = mrOK Then
     Begin
       MessageBeep(MB_ICONEXCLAMATION);
       If MessageDlg('Auch die Dateien lschen? VORSICHT DATENVERLUST!',
                     mtWarning, [mbYes, mbNo], 0               ) = mrYes Then
          SubstanzDateienLoeschen(1, Pred(SubstanzenNStringGrid.RowCount));
       With SubstanzenNStringGrid Do
            Begin
              RowCount := 2;
              ClearRow(1)
            End;
     End;

end;




procedure TDBEinstForm.PrimSignComboBoxChange(Sender: TObject);
begin
  //Auf diese Weise sind gleiche Eintrge in PrimSignComboBox und
  //OffsetComboBox nicht mehr mglich
  If PrimSignComboBox.ItemIndex = OffsetComboBox.ItemIndex Then
     Begin
       MessageBeep(MB_ICONSTOP);
       MessageDlg('Primres Signal und Offsetsignal mssen sich unterscheiden!',
                  mtError, [mbOK], 0);
       If OffsetComboBox.ItemIndex = 0 Then PrimSignComboBox.ItemIndex := 1
                                       Else PrimSignComboBox.ItemIndex := 0;
     End
end;



procedure TDBEinstForm.OffsetComboBoxChange(Sender: TObject);
begin
  //Auf diese Weise sind gleiche Eintrge in PrimSignComboBox und
  //OffsetComboBox nicht mehr mglich
  If PrimSignComboBox.ItemIndex = OffsetComboBox.ItemIndex Then
     Begin
       MessageBeep(MB_ICONSTOP);
       MessageDlg('Offsetsignal und Primres Signal mssen sich unterscheiden!',
                  mtError, [mbOK], 0);
       If PrimSignComboBox.ItemIndex = 0 Then OffsetComboBox.ItemIndex := 1
                                         Else OffsetComboBox.ItemIndex := 0;
     End
end;



end.
