unit FehlerSammlungFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, NStringGridKomponente;

type
  TFehlersammlungForm = class(TForm)
    FehlerNStringGrid: TNStringGrid;
    FehelLabel: TLabel;
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }

    Procedure Reset;

    Procedure InFehler(Signal_s, Fehler_s : String);

    Procedure FehlerAnzeigen;
  end;

var
  FehlersammlungForm: TFehlersammlungForm;

implementation

{$R *.DFM}



Procedure TFehlersammlungForm.FehlerAnzeigen;
Begin
  With FehlerNStringGrid Do
       If Not((RowCount = 2) And (StrRead_s(1, 1) = '')) Then
          Begin
            MessageBeep(MB_ICONSTOP);
            MessageDlg('Es sind Fehler aufgetreten!', mtError, [mbOK], 0);
            ShowModal;
          End
End;



Procedure TFehlersammlungForm.InFehler(Signal_s, Fehler_s : String);
Begin
  If Not(Fehler_s = '') Then
     With FehlerNStringGrid Do
          Begin
            If Not((RowCount = 2) And (StrRead_s(1, 1) = '')) Then
               RowCount := RowCount + 1;
            StrWrite(0, Pred(RowCount), Signal_s);
            StrWrite(1, Pred(RowCount), Fehler_s);
        End
End;



Procedure TFehlersammlungForm.Reset;
Begin
  FehlerNStringGrid.StrWrite(0, 1, '');
  FehlerNStringGrid.StrWrite(1, 1, '');
  FehlerNStringGrid.RowCount := 2;
End;


procedure TFehlersammlungForm.FormCreate(Sender: TObject);
begin
  FehlerNStringGrid.StrWrite(0, 0, 'Signal');
  FehlerNStringGrid.StrWrite(1, 0, 'Fehler');
  FehlerNStringGrid.RowCount := 2;
end;


end.
