unit Hauptformular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Buttons, ExtCtrls, ComCtrls, Grids,
  Calendar, OleCtrls, DatenKlasse, DBCtrls, Me1400Klasse,
  EinstellungsFormular, ProgInfoFormular, WellenKalFormular,
  autointegrationsformular, Datenbankformular, signaleformular, CPortCtl, CPort;

Type
  //tanzeige = (anzChrom, anzSpekDP, anzSpekNM); Typisiert den Anzeigemodus:
                                               //siehe Datenobjekt
  THauptForm = class (TForm)
    MainMenu: TMainMenu;
    Datei1: TMenuItem;
    Laden1: TMenuItem;
    AnsichtMenuItem: TMenuItem;
    Vergrern1: TMenuItem;
    Verkleinern1: TMenuItem;
    Ausgangsgre1: TMenuItem;
    Integrationsbereich1: TMenuItem;
    Nullabgleich1: TMenuItem;
    Beenden1: TMenuItem;
    Panel1: TPanel;
    groesser: TBitBtn;
    Kleiner: TBitBtn;
    Normal: TBitBtn;
    intbereich: TBitBtn;
    NullabgleichBitBtn: TBitBtn;
    StatusBar: TStatusBar;
    OpenDialog: TOpenDialog;
    Ausfuehren: TBitBtn;
    SpeichernUnterMenuItem: TMenuItem;
    Ausf: TMenuItem;
    y_bezeichnung: TLabel;
    MessenBitBtn: TBitBtn;
    EinstMenueItem: TMenuItem;
    SaveChrDialog: TSaveDialog;
    bearbeiten_menue: TMenuItem;
    Basislinienangleichen1: TMenuItem;
    AnzeigenMenueItem: TMenuItem;
    ableitung: TMenuItem;
    rueckgaengig: TMenuItem;
    glaetten: TMenuItem;
    N1: TMenuItem;
    Ueber: TMenuItem;
    PixelModusMenuItem: TMenuItem;
    nmModusMenuItem: TMenuItem;
    SpektrumMenuItem: TMenuItem;
    WellenKalMenueItem: TMenuItem;
    a_integration_menue: TMenuItem;
    MessenMenuItem: TMenuItem;
    DatenbankMainMenue: TMenuItem;
    OriginMenue: TMenuItem;
    SkalierenMenue: TMenuItem;
    LadenBitBtn: TBitBtn;
    SpeichernBitBtn: TBitBtn;
    AIntegrationBitBtn: TBitBtn;
    ManuelSkalierenBitBtn: TBitBtn;
    KoordinatenLabel: TLabel;

    ChromImage    : TImage;    //Enthlt die graphische Darstellung des
                               //Chromatogrammes oder Spektrums
    AchsenImage   : TImage;    //Enthlt die Achsen nebst Bezeichnungen und die
                               //Linienbezeichnungen des Chromatogrammes
    FRectPaintBox : TPaintBox;
    ChromPaintBox: TPaintBox;
    SignalMenueItem: TMenuItem;
    ExtStandardMenueItem: TMenuItem;
    NormierenMenueItem: TMenuItem;
    LinienauswahlMenuItem: TMenuItem;
    DBEinstMenuItem: TMenuItem;
    ComLed: TComLed;
    DriftkorrekturMenueItem: TMenuItem;
    BearbeitenMenuItem: TMenuItem;
    Ausschnittkopieren1: TMenuItem;
    Alleskopieren1: TMenuItem;
    Datenbank1: TMenuItem;
    Spektrum1: TMenuItem;
    SeparatorMenueItem: TMenuItem;
    Separator2MenueItem: TMenuItem;
    Separator3MenueItem: TMenuItem;
    Separator4MenueItem: TMenuItem;
    LinLoeschenMenueItem: TMenuItem;
    PrintDialog: TPrintDialog;
    D1: TMenuItem;
    SpeichernMenuItem: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    StAVerzMenueItem: TMenuItem;
    N4: TMenuItem;
    InfoMenuItem: TMenuItem;
    AnzAuswertenSpeedButton: TSpeedButton; //Gleiche Mae wie ChromImage: Enthlt das
                               //Fokusierrechteck, da "TImage" zu lansam
                               //ist um es darzustellen. Der Vorteil von
                               //"TImage" ist, dass die Darstellung des
                               //Chromatogramms/Spektrums nicht durch das
                               //Verschieben von Fenstern, die sich im
                               //Vordergrund befinden, gelscht werden kann.

    procedure Beenden1Click(Sender: TObject);

    procedure FRectPaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure FRectPaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure NormalClick(Sender: TObject);
    procedure KleinerClick(Sender: TObject);
    procedure AusfuehrenClick(Sender: TObject);
    procedure groesserClick(Sender: TObject);
    procedure intbereichClick(Sender: TObject);
    procedure NullabgleichBitBtnClick(Sender: TObject);
    procedure MessenBitBtnClick(Sender: TObject);
    procedure EinstMenueItemClick(Sender: TObject);
    procedure Basislinienangleichen1Click(Sender: TObject);
    procedure AnzeigenMenueItemClick(Sender: TObject);
    procedure rueckgaengigClick(Sender: TObject);
    procedure ableitungClick(Sender: TObject);
    procedure glaettenClick(Sender: TObject);
    procedure UeberClick(Sender: TObject);
    procedure SpektrumMenuItemClick(Sender: TObject);
    procedure WellenKalMenueItemClick(Sender: TObject);
    procedure nmModusMenuItemClick(Sender: TObject);
    procedure PixelModusMenuItemClick(Sender: TObject);
    procedure a_integration_menueClick(Sender: TObject);
    procedure DatenbankMainMenueClick(Sender: TObject);
    procedure OriginMenueClick(Sender: TObject);
    procedure LadenBitBtnClick(Sender: TObject);
    procedure ManuelSkalierenBitBtnClick(Sender: TObject);
    procedure FRectPaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ExtStandardMenueItemClick(Sender: TObject);
    procedure NormierenMenueItemClick(Sender: TObject);
    procedure LinienauswahlMenuItemClick(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure DBEinstMenuItemClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DriftkorrekturMenueItemClick(Sender: TObject);
    procedure Ausschnittkopieren1Click(Sender: TObject);
    procedure Alleskopieren1Click(Sender: TObject);
    procedure LinLoeschenMenueItemClick(Sender: TObject);
    procedure D1Click(Sender: TObject);
    procedure SpeichernMenuItemClick(Sender: TObject);
    procedure SpeichernUnterMenuItemClick(Sender: TObject);
    procedure StAVerzMenueItemClick(Sender: TObject);
    procedure InfoMenuItemClick(Sender: TObject);

  private { Private-Deklarationen }

    FRect : TRect; //Koordinaten des Auswahlrechtecks = Fokusrechtecks

    chrom_gespeichert_b : Boolean;

    anzeige : tanzeige; //Enthlt den Anzeigemodus (ob Chromatogramm, Spektrum
                        //in Abhngigkeit von Pixeln oder der Wellenlnge);
                        //gehrt zur Property "anzeigemodus"

    AktDatPfad_s : String; //Pfad und Name der aktuell geladenen Datei

    Procedure auswahlrechteck_zuruecksetzen;//zurcksetzen des Fokosierrechtecks
    Function vorher_speichern : Boolean;

    Procedure DisplayHint(Sender: TObject);//Leitet alle Hints in die Status-
                                           //leiste um.

    procedure staendiger_hinweis(Sender: TObject);
    //Macht den Hint des BitButtons, der den Fokus hat zum Hint des gesamten
    //Fensters.

    Procedure anzmodchange(Value : tanzeige); //ndert den Anzeigemodus

    Property anzeigemodus : tanzeige Read anzeige Write anzmodchange;
             //Anzeigemodus: Ob Chromatogramm, Spektrum in Abhngigkeit von der
             //Pixelzahl oder in Abhngigkeit von der Wellenlnge

    Procedure AktPfadLeeren;

  public
    { Public-Deklarationen }
end;





var HauptForm    : THauptForm;
    Daten        : TDaten;




implementation

uses Skalierungsformular, ExtStandardFormular, StAVerzeichnisFormular;

{$R *.DFM}





Procedure THauptForm.AktPfadLeeren;
Begin
  AktDatPfad_s             := '';
  Caption                  := 'Spektrograph';
  Application.Title        := 'Spektrograph';
  StatusBar.Panels[1].Text := 'Integrierte Signale: 0';
End;



Procedure THauptForm.anzmodchange(Value : tanzeige);

Procedure nach_chrom;
Begin
  With PixelModusMenuItem Do Checked := True;
  With nmModusMenuItem    Do Checked := False;
  With PixelModusMenuItem Do Enabled := False;
  With nmModusMenuItem    Do Enabled := False;
  With SignaleForm        Do modus   := moChrom
End;

Procedure nach_pixel;
Begin
  With nmModusMenuItem    Do Checked := False;
  With PixelModusMenuItem Do Checked := True;
  With PixelModusMenuItem Do Enabled := True;
  With nmModusMenuItem    Do Enabled := True;
  With SignaleForm        Do modus   := moSpektr
End;

Procedure nach_nm;
Begin
  nach_pixel;
  With nmModusMenuItem    Do Checked := True;
  With PixelModusMenuItem Do Checked := False;
End;

Begin  //anzmodchange
  Case Value Of
       anzChrom  : nach_chrom;
       anzSpekPI : nach_pixel;
       anzSpekNM : nach_nm
    End;
  anzeige := Value
End;





Function THauptForm.vorher_speichern : Boolean;
//Warnt vor Datenverlust und fordert zum Speichern auf; False, falls Abbruch
//gewhlt wurde

Var id_i : Integer; //Rckgabewert der Messagebox, 0 = konnte nicht ausgefhrt
                    //werden, 6 = mit Ja geantwortet

Begin
  id_i := Application.MessageBox('Chromatogramm + Integrale vorher speichern?',
                                 'Frage', MB_YESNOCANCEL + MB_ICONQUESTION);
  If id_i = 2 Then Result := False
     Else Result := True;
  If (id_i = 0) Or (id_i = 6) Then SpeichernUnterMenuItemClick(Laden1)
End;





procedure THauptForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If Not(chrom_gespeichert_b) Then
     If Not(vorher_speichern) Then
        Begin
          Action := caNone;
          Exit
        End;
  daten.free;
end;





procedure THauptForm.Beenden1Click(Sender: TObject);
begin
  Close
end;





Procedure THauptForm.auswahlrechteck_zuruecksetzen;
Begin
  FRect.Left   := 0;
  FRect.top    := 0;
  FRect.right  := 0;
  FRect.Bottom := 0
End;





procedure THauptForm.FRectPaintBoxMouseDown(Sender : TObject;
                                            Button : TMouseButton;
                                            Shift  : TShiftState;
                                            X, Y   : Integer);

//Die linke Maustaste wird zur Erzeugung eines Fokosierrechteck gedrckt.

Begin
   If ssleft IN shift Then //Falls die LINKE Maustaste gedrckt gehalten wird...
      Begin
        FRect.left   := x; //Die Anfangskoordinaten fr das
        FRect.top    := y; //Fokusierrechteck werden in dem
        FRect.right  := x; //vordefinierten Record "rect" gespeichert.
        FRect.bottom := y;
        FRectPaintBox.canvas.DrawFocusRect(FRect)//zeichnet das Focosierrechteck
      End Else If Button = mbRight Then
         If Not(Daten = Nil) Then With daten Do
                                       Begin
                                         kleiner.SetFocus;
                                         zoom_minus
                                       End
End;





procedure THauptForm.FRectPaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);

//Das Fokosierrechteck wird aufgezogen.

begin
  With KoordinatenLabel Do
       Begin
         If Not(daten = Nil) Then
            Caption  := daten.KoordinatenAusgeben_s(ChromImage.Width,
                                                    ChromImage.Height,
                                                    x, y, Anzeige);
         Left     := HauptForm.ClientWidth - Width - 20
       End;
  If ssleft IN shift Then // Falls die LINKE Maustaste gedrckt gehalten wird...
     With FRectPaintBox.Canvas, FRectPaintBox Do
          Begin
            DrawFocusRect(FRect); //...lscht das alte Fokosierrechteck,
            FRect.right  := x;    //...setzt die neuen Koordinaten und
            FRect.bottom := y;
            DrawFocusRect(FRect); //...zeichnet das Fokosierrechteck mit
          End                     //   den neuen Koordinaten.
end;





procedure THauptForm.FRectPaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

//Das Fokosierrechteck wird nach Abschu der Auswahl durch das Loslassen
//der linken Maustaste wieder gelscht.

begin
  If mbRight = Button Then Exit;
  FRectPaintBox.Canvas.DrawFocusRect(FRect);  //...lscht das Fokosierrechteck
  FRect.right  := x;              //Den ausgewhlten Bereich speichert "FRect"
  FRect.bottom := y;
  If (FRect.Left <= FRect.Right) And (FRect.Top <= FRect.Bottom) Then
     With daten, ChromImage Do//Falls kein gltiges Rechteck aufgezogen wurde...
          Begin
            If groesser.focused   Then ZoomIn(Width, Height, FRect);
            If intbereich.focused Then peakbereich_setzen(Width, Height, FRect);
            If NullabgleichBitBtn.focused Then
               blankbereich_setzen(Width, Height, FRect);
            If Not(Daten = Nil) Then
               darstellen(ChromImage, AchsenImage, anzeigemodus)
          End
End;




procedure THauptForm.FormCreate(Sender: TObject);
begin
  //Die Instanzen der bentigten Objekte werden erzeugt
  Try With daten Do daten := TDaten.Create;  //enthlt das Chromatogramm

  Except Application.MessageBox('Schwerwiegender Initalisierungsfehler!',
                                'Fehlermeldung', Mb_Ok + MB_ICONSTOP)
  End;

  StatusBar.Panels[0].Width := HauptForm.ClientWidth Div 2;
  StatusBar.Panels[1].Width := HauptForm.ClientWidth Div 2;
  StatusBar.Panels[1].Text  := 'Integrierte Signale: 0';
  With KoordinatenLabel Do
       Begin
         Caption  := 'X: 0, Y: 0';
         Left     := HauptForm.ClientWidth - Width - 20
       End;

  With ChromImage Do
       Begin
         Top    := 50;
         Left   := 50;
         Height := HauptForm.ClientHeight - 100;
         Width  := HauptForm.ClientWidth  - 50
       End;

  FRectPaintBox.BoundsRect := ChromImage.BoundsRect;
  ChromPaintBox.BoundsRect := ChromImage.BoundsRect;

  With AchsenImage Do
       Begin
         Left   := 0;
         Top    := 0;
         Width  := HauptForm.ClientWidth;
         Height := HauptForm.ClientHeight - 19;
         Canvas.Brush.Color := clBtnFace;
         Canvas.FloodFill(10, 10, clBtnFace, fsBorder);

         Canvas.Pen.Color := clBlack;
         Canvas.brush.Color := clWhite;
         Canvas.Rectangle(ChromImage.BoundsRect)
       End;

  Application.ShowHint := True;
  
  With y_bezeichnung Do
       Begin
         Top  := ChromImage.top + ChromImage.Height Div 2 - Height Div 2;
         Left := ChromImage.Left Div 5
       End;

  With Panel1 Do Width := HauptForm.ClientWidth;
  auswahlrechteck_zuruecksetzen;

  Application.OnHint     := DisplayHint;//Das Ereignis OnHint lst DisplayHint
                                        //aus.

  Screen.OnActiveControlChange := staendiger_hinweis; //Das Ergeignis Focus-
                                                      //wechsel lst
                                                      //staendiger_hinweis aus.

  chrom_gespeichert_b := True;  //berwacht, ob sich nicht auf dem Daten-
                                //trger gesicherte Daten im Speicher befinden

  AktPfadLeeren;  //Damit die Titel in der Taskleiste und im Hauptformular
                  //stimmen
end;





procedure THauptForm.NormalClick(Sender: TObject);
begin
  If Not(daten = Nil) Then
     With daten Do
          Begin
            zoom_norm;
            darstellen(ChromImage, AchsenImage, anzeigemodus)
          End
end;





procedure THauptForm.KleinerClick(Sender: TObject);
begin
  If Not(daten = Nil) Then
     With daten Do
          Begin
            zoom_minus;
            daten.darstellen(ChromImage, AchsenImage, anzeigemodus)
          End;
  kleiner.SetFocus
end;





procedure THauptForm.AusfuehrenClick(Sender: TObject);
begin
  If Not(daten = Nil) Then
     Case daten.peak_bestimmung Of
          asOk      : Begin
                        StatusBar.Panels[1].Text := 'Integrierte Signale: ' +
                                           IntToStr(Daten.signalzahl_i);
                        chrom_gespeichert_b := False
                      End;
          asZuviele :
                Application.MessageBox('Maximale Integralanzahl berschritten!',
                                       'Fehlermeldung', Mb_Ok + MB_ICONSTOP);
          asKeinBereich : Application.MessageBox('Bereiche nicht gesetzt!',
                                                 'Fehlermeldung',
                                                 Mb_Ok + MB_ICONSTOP);
        End;
  ausfuehren.SetFocus
end;





procedure THauptForm.groesserClick(Sender: TObject);
begin
  groesser.setfocus
end;





procedure THauptForm.intbereichClick(Sender: TObject);
begin
  intbereich.setfocus
end;





procedure THauptForm.NullabgleichBitBtnClick(Sender: TObject);
begin
  NullabgleichBitBtn.setfocus
end;





procedure THauptForm.MessenBitBtnClick(Sender: TObject);

Var fehler_b : Boolean;

begin
  messenBitBtn.setfocus;

  If Not(daten = Nil) Then
     Begin
       Screen.Cursor := crHourGlass;
       If chrom_gespeichert_b Or vorher_speichern Then
          Begin
            With einstform Do
                 daten.ChromRS232(AchsenImage,
                                  ChromImage,
                                  ChromPaintBox,
                                  StatusBar,
                                  ComLed,
                                  blzNEdit.IntRead_i,
                                  ZeitVorschauNEdit.IntRead_i,
                                  IntVorschauNEdit.IntRead_i);
            AktPfadLeeren;
            chrom_gespeichert_b := False;
            anzeigemodus := anzChrom; //Schaltet den Chromatographiemodus ein
          End;

       daten.darstellen(ChromImage, AchsenImage, anzeigemodus);
       Screen.Cursor := crDefault
     End
end;





procedure THauptForm.EinstMenueItemClick(Sender: TObject);
begin
  EinstForm.ShowModal
end;





procedure THauptForm.Basislinienangleichen1Click(Sender: TObject);
begin
  If Not(daten = Nil) Then
     Begin
       chrom_gespeichert_b := False;
       If daten.BasislinienAngleichen(True) Then rueckgaengig.Enabled := True;
       daten.darstellen(ChromImage, AchsenImage, anzeigemodus)
     End
end;






procedure THauptForm.AnzeigenMenueItemClick(Sender: TObject);
begin
  If Not(daten = Nil) Then
     Begin
       With Daten Do If SignaleBearbeiten_b Then chrom_gespeichert_b := False;
       StatusBar.Panels[1].Text :=   'Integrierte Signale: '
                                   + IntToStr(Daten.signalzahl_i)
     End
end;



procedure THauptForm.rueckgaengigClick(Sender: TObject);
begin
  If Not (daten = Nil) Then
     Begin
       daten.undo;
       rueckgaengig.Enabled := False;
       daten.darstellen(ChromImage, AchsenImage, anzeigemodus)
     End
end;



procedure THauptForm.ableitungClick(Sender: TObject);
begin
  If Not (daten = Nil) Then
     Begin
       With daten Do
            Begin
              ableiten;
              darstellen(ChromImage, AchsenImage, anzeigemodus);
              chrom_gespeichert_b := False;
            End;
       rueckgaengig.Enabled := True
     End
end;



procedure THauptForm.glaettenClick(Sender: TObject);
begin
  If Not (daten = Nil) Then
     With daten Do
          Begin
            If glaetten Then
               Begin
                 rueckgaengig.Enabled := True;
                 chrom_gespeichert_b  := False
               End;
            darstellen(ChromImage, AchsenImage, anzeigemodus)
          End
end;



Procedure THauptForm.DisplayHint(Sender: TObject);
Begin
  StatusBar.Panels[0].Text := GetLongHint(Application.Hint)
End;




procedure THauptForm.staendiger_hinweis(Sender: TObject);

Var i : Integer;

begin //Macht den Hint des BitButtons, der den Fokus zum Hint des
      //gesamten Fensters.
  With panel1 Do
       for I:= 0 to ControlCount -1 do
           if Controls[I] is TWinControl then
              If (Controls[I] as TWinControl).Focused then
                 HauptForm.Hint := GetShortHint(Controls[I].Hint)
end;




procedure THauptForm.UeberClick(Sender: TObject);
begin
   InfoForm.ShowModal;
end;




procedure THauptForm.SpektrumMenuItemClick(Sender: TObject);
begin
  If Not (daten = Nil) Then
     Begin
       If chrom_gespeichert_b Or vorher_speichern Then
          Begin
            StatusBar.Panels[0].Text := 'Spektrum aufnehmen!';
            StatusBar.Repaint;
            MessageBeep(MB_ICONEXCLAMATION);
            MessageDlg('"OK" drcken um das Spektrum jetzt aufzunehmen!',
                       mtInformation, [mbOK], 0                       );
                       Screen.Cursor := crHourGlass;
            daten.SpektrumRS232;
            Screen.Cursor       := crDefault;
            anzeigemodus        := anzSpekPI;
            chrom_gespeichert_b := False;
            AktPfadLeeren;
          End;
       daten.darstellen(ChromImage, AchsenImage, anzeigemodus);
     End
end;



procedure THauptForm.WellenKalMenueItemClick(Sender: TObject);
begin
  If Not (daten = Nil) Then
     Begin
       WellenKalForm.ShowModal;
       daten.darstellen(ChromImage, AchsenImage, anzeigemodus);
       AktPfadLeeren;
     End
end;



procedure THauptForm.nmModusMenuItemClick(Sender: TObject);
begin
  If Not (daten = Nil) Then
     Begin
       anzeigemodus := anzSpekNM;
       daten.darstellen(ChromImage, AchsenImage, anzeigemodus)
     End
end;



procedure THauptForm.PixelModusMenuItemClick(Sender: TObject);
begin
  If Not (daten = Nil) Then
     Begin
       anzeigemodus := anzSpekPI;
       daten.darstellen(ChromImage, AchsenImage, anzeigemodus)
     End
end;



procedure THauptForm.a_integration_menueClick(Sender: TObject);  //automatische
                                                                  //Integration
Var status : TAuswerteStatus;

begin
  AIntegrationBitBtn.SetFocus;

  If Not (daten = Nil) Then With Daten Do
    Begin
      status := AutoAuswertung;
      Case status Of
           asOk : StatusBar.Panels[1].Text := 'Integrierte Signale: ' +
                                              IntToStr(Daten.signalzahl_i);

           asZuviele :
                Application.MessageBox('Maximale Integralanzahl berschritten!',
                                      'Fehlermeldung', Mb_Ok);
           asKeinBereich :
                Application.MessageBox('Undefinierter Nullabgleichsbereich!',
                                       'Fehlermeldung', Mb_Ok)
          End;
      If Not(status = asKeinBereich) Then chrom_gespeichert_b := False;
      darstellen(ChromImage, AchsenImage, anzeigemodus)
    End
end;



procedure THauptForm.DatenbankMainMenueClick(Sender: TObject);
begin
  DatenbankForm.ShowModal(daten)
end;



procedure THauptForm.OriginMenueClick(Sender: TObject);
begin
  If Not (daten = Nil) Then
     Begin
       daten.orginaldaten_wiederherstellen;
       rueckgaengig.Enabled := True;
       chrom_gespeichert_b  := False;
       daten.darstellen(ChromImage, AchsenImage, anzeigemodus)
     End
end;



procedure THauptForm.LadenBitBtnClick(Sender: TObject);

Var chrom_b  : Boolean;
    fehler_b : Boolean;
    import_b : Boolean;

begin
  ladenBitBtn.SetFocus;
  auswahlrechteck_zuruecksetzen;

  If Not (daten = Nil) Then
     Begin
       If chrom_gespeichert_b Or vorher_speichern Then
          If OpenDialog.Execute Then
             Begin
               Screen.Cursor := crHourGlass;
               daten.laden(OpenDialog.FileName, chrom_b, fehler_b, import_b);
               Screen.Cursor := crDefault;
               If chrom_b Then anzeigemodus := anzChrom
                  Else anzeigemodus := anzSpekPI;
               If fehler_b Then
                  Application.MessageBox('Fehler beim Laden der Datei!',
                                         'Fehlermeldung', Mb_Ok);

               //Beim Import werden Daten zum Chromatogramm abgefragt, die dann
               //natrlich noch nicht gespeichert sind.
               chrom_gespeichert_b := Not(Import_b);
               
               rueckgaengig.Enabled := False;

               StatusBar.Panels[1].Text := 'Integrierte Signale: ' +
                                           IntToStr(Daten.signalzahl_i);
               AktDatPfad_s      := OpenDialog.FileName;
               Caption           := 'Spektrograph - ' + AktDatPfad_s;
               Application.Title := 'Spektrograph - ' + AktDatPfad_s;
             End;
       daten.darstellen(ChromImage, AchsenImage, anzeigemodus)
     End
end;




procedure THauptForm.ManuelSkalierenBitBtnClick(Sender: TObject);
begin
  ManuelSkalierenBitBtn.SetFocus;
  If Not(daten = Nil) Then
     Begin
       Daten.SkalierungVorwaehlen(anzeigemodus);
       Daten.Darstellen(ChromImage, AchsenImage, anzeigemodus)
     End;
end;




procedure THauptForm.ExtStandardMenueItemClick(Sender: TObject);
begin
  If Not (daten = Nil) Then ExtStandardForm.ModalZeigen(daten)
end;




procedure THauptForm.NormierenMenueItemClick(Sender: TObject);
begin
  If Not (daten = Nil) Then
     Begin
       With ExtStandardForm Do
            If daten.normieren_b Then
               rueckgaengig.Enabled := True;
       daten.darstellen(ChromImage, AchsenImage, anzeigemodus)
     End
end;




procedure THauptForm.LinienauswahlMenuItemClick(Sender: TObject);
begin
  If Not(Daten = Nil) Then
     Begin
       Daten.SignaleAusblenden;
       daten.darstellen(ChromImage, AchsenImage, anzeigemodus)
     End
end;




procedure THauptForm.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
If (NewWidth  > Screen.DesktopWidth  - 100) And
   (NewHeight > Screen.DesktopHeight - 100) Then
     Begin
       HorzScrollBar.Visible := False;
       VertScrollBar.Visible := False
     End
     Else
     Begin
       HorzScrollBar.Visible := True;
       VertScrollBar.Visible := True
     End
end;




procedure THauptForm.DBEinstMenuItemClick(Sender: TObject);
begin
  If Not(Daten = Nil) Then With Daten Do DBEinstAendern;
End;




procedure THauptForm.FormShow(Sender: TObject);
begin
  //Das Standardarbeitsverzeichnis wird gesetzt: Dieses Verzeichnis ist das
  //aktuelle Verzeichnis, wenn die Laden- und Speichern-Dialogboxen fr die
  //Spektren und Chromatogramme aufgerufen werden. (Wichtig: Das Standard-
  //Arbeitsverzeichnis fr die Methoden und die Datenbank ist das Stammverzeich-
  //nis der Software (von Spektrograph). D. h. es existieren zwei Standardar-
  //beitsverzeichnisse, aber nur das fr die Chromatogramme und Spektren kann
  //man festlegen.
  OpenDialog.   InitialDir := StaVerzeichnisForm.StAVerzeichnis_s_prop;
  SaveChrDialog.InitialDir := StaVerzeichnisForm.StAVerzeichnis_s_prop;

  //Bei einem doppelten Programmstart kann nur eine Instanz mit dem Spektrometer
  //kommunizieren, da es sonst zu Konflikten kommt. Prioritt hat die zuerst
  //gestartete Instanz.
  If EinstForm.DoppelterStart_b Then
     Begin
       MessenBitBtn.Enabled   := False;
       MessenMenuItem.Enabled := False;
     End;
  If (Daten = Nil) Then Close
end;



procedure THauptForm.DriftkorrekturMenueItemClick(Sender: TObject);
begin
  If Not (daten = Nil) Then
     Begin
       With ExtStandardForm Do
            If daten.driftweg_b Then
               rueckgaengig.Enabled := True;
       daten.darstellen(ChromImage, AchsenImage, anzeigemodus)
     End
end;




procedure THauptForm.Ausschnittkopieren1Click(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  If Not(daten = Nil) Then Daten.AuswahlInZwischenablage;
  Screen.Cursor := crDefault
end;




procedure THauptForm.Alleskopieren1Click(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  If Not(daten = Nil) Then Daten.AllesInZwischenablage;
  Screen.Cursor := crDefault
end;




procedure THauptForm.LinLoeschenMenueItemClick(Sender: TObject);
begin
  If Not(daten = Nil) Then
     Begin
       If daten.LinienLoeschen_b Then Chrom_Gespeichert_b := False;
       daten.darstellen(ChromImage, AchsenImage, Anzeige)
     End;
end;




procedure THauptForm.D1Click(Sender: TObject);
//Druckt einen Screenshot
begin
  If PrintDialog.Execute Then HauptForm.Print
end;



procedure THauptForm.SpeichernMenuItemClick(Sender: TObject);
begin
  If AktDatPfad_s = '' Then SpeichernUnterMenuItemClick(Sender)
     Else
     Begin
       speichernBitBtn.SetFocus;
       auswahlrechteck_zuruecksetzen;
       Screen.Cursor := crHourGlass;
       If Not (daten = Nil) Then
          With daten Do
               If chrom_speichern(AktDatPfad_s, Not(nmModusMenuItem.enabled))
                  Then
                  chrom_gespeichert_b := True
                  Else
                  Application.MessageBox('Fehler beim Speichern der Datei!',
                                         'Fehlermeldung', Mb_Ok);
       Screen.Cursor := crDefault;
     End
end;



procedure THauptForm.SpeichernUnterMenuItemClick(Sender: TObject);
begin
  speichernBitBtn.SetFocus;
  auswahlrechteck_zuruecksetzen;
  If Not (daten = Nil) Then
     With daten Do
          If SaveChrDialog.Execute Then
             Begin
               Screen.Cursor := crHourGlass;
               If chrom_speichern(SaveChrDialog.FileName,
                                  Not(nmModusMenuItem.enabled)) Then
                  Begin
                    chrom_gespeichert_b := True;
                    AktDatPfad_s        := SaveChrDialog.FileName;
                    Caption             := 'Spektrograph - ' + AktDatPfad_s;
                    Application.Title   := 'Spektrograph - ' + AktDatPfad_s;
                  End
                  Else
                  Application.MessageBox('Fehler beim Speichern der Datei!',
                                         'Fehlermeldung', Mb_Ok);
               Screen.Cursor := crDefault;
             End
end;



procedure THauptForm.StAVerzMenueItemClick(Sender: TObject);

Var StAPfad_s : String;

begin
  StAVerzeichnisForm.ShowModal(StAPfad_s);
  OpenDialog.InitialDir    := StAPfad_s;
  SaveChrDialog.InitialDir := StAPfad_s
end;



procedure THauptForm.InfoMenuItemClick(Sender: TObject);
begin
  If Not(daten = Nil) Then daten.Info
end;



end.
