unit LinienUmbenennenFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, NStringGridKomponente, EinstellungsFormular;

type
  TLines_a_s = Array[1..MAXLINZAHL_I] OF String;

  TLinienUmbenennenForm = class(TForm)
    LinienNStringGrid: TNStringGrid;
    ok: TBitBtn;
    abbruch: TBitBtn;
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Function ShowModal(Var LinNamen_s    : String) : Integer; Overload;
    Function ShowModal(Var lines_a_s  : TLines_a_s) : Integer; Overload;
  end;

var
  LinienUmbenennenForm: TLinienUmbenennenForm;

implementation

{$R *.DFM}



Function TLinienUmbenennenForm.ShowModal(Var LinNamen_s : String) : Integer;

Const TRENNZEICHEN = ';';

Var NeuLinNamen_s : String;
    j, i          : Integer;

Begin
  With LinienNStringGrid Do
       Begin
         RowCount := 2;
         j := 1;
         StrWrite(0, j, '');
         For i := 1 To Length(LinNamen_s) Do
             If LinNamen_s[i] = TRENNZEICHEN Then
                Begin
                  Inc(j);
                  RowCount := Succ(j);
                  StrWrite(0, j, '')
                End
                Else StrWrite(0, j, StrRead_s(0, j) + LinNamen_s[i])
       End;
  MessageBeep(MB_ICONHAND);
  If MessageDlg(  'Das Umbenennen von Linien kann nicht '
                + 'rckgngig gemacht werden! '
                + 'Trotzdem fortfahren?',
                mtWarning, [mbYes, mbNo], 0               ) = mrYES Then
     Result := ShowModal
     Else
     Result := mrCancel;
  If Result = mrOK Then
     Begin
       NeuLinNamen_s := '';
       For i := 1 To Pred(LinienNStringGrid.RowCount) Do
           NeuLinNamen_s :=   NeuLinNamen_s
                            + LinienNStringGrid.StrRead_s(0, i) + ';';
       If Not(NeuLinNamen_s = '') Then
          If NeuLinNamen_s[Length(NeuLinNamen_s)] = ';' Then
             SetLength(NeuLinNamen_s, Pred(Length(NeuLinNamen_s)));
       LinNamen_s := NeuLinNamen_s
     End
End;



Function TLinienUmbenennenForm.ShowModal(Var lines_a_s  : TLines_a_s) : Integer;

Var i : Integer;

Begin
  For i := 1 To MAXLINZAHL_i Do
      If Not(Lines_a_s[i] = '') Then
         Begin
           LinienNStringGrid.RowCount := Succ(i);
           LinienNStringGrid.StrWrite(0, i, Lines_a_s[i]);
         End;
  Result := ShowModal;
  If Result = mrOK Then
     For i := 1 To Pred(LinienNStringGrid.RowCount) Do
         Begin
           If LinienNStringGrid.StrRead_s(0, i) = '' Then
              LinienNStringGrid.StrWrite(0, i, '?');
           Lines_a_s[i] := LinienNStringGrid.StrRead_s(0, i)
         End;
End;



end.
