unit SubstanzFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TSubstanzForm = class(TForm)
    NameEdit: TEdit;
    PfadEdit: TEdit;
    Label1: TLabel;
    PfadLabel: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    LadenBitBtn: TBitBtn;
    procedure LadenBitBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }

    OpenDialog : TOpenDialog;

  public
    { Public-Deklarationen }
    Procedure ModalAnzeigen(Var name_s, pfad_s  : String;
                                SubstOpenDialog : TOpenDialog);
  end;

var
  SubstanzForm: TSubstanzForm;

implementation

{$R *.DFM}



procedure TSubstanzForm.LadenBitBtnClick(Sender: TObject);

Var Datei_txt : TextFile;
    ok_b      : Boolean;

begin
  With OpenDialog Do
  If Execute Then
     If FileExists(FileName) Then PfadEdit.Text := OpenDialog.FileName
        Else
        Begin
          Try AssignFile(datei_txt, OpenDialog.FileName);
              Rewrite(datei_txt);
              CloseFile(datei_txt);
              Erase(datei_txt);
              ok_b := True;
          Except ok_b := False
          End;
          If ok_b Then PfadEdit.Text := OpenDialog.FileName
        End
end;



Procedure TSubstanzForm.ModalAnzeigen(Var name_s, pfad_s      : String;
                                          SubstOpenDialog     : TOpenDialog);
Begin
  OpenDialog := SubstOpenDialog;
  NameEdit.Text := name_s;
  PfadEdit.Text := pfad_s; 
  If ShowModal = mrOK Then
     Begin
       name_s := NameEdit.Text;
       pfad_s := PfadEdit.Text
     End
     Else
     Begin
       name_s := '';
       pfad_s := ''
     End
End;



end.
