unit Einstellungsformular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, checklst, Grids, Buttons, Me1400Klasse,
  ExtCtrls, StringGitter, ComCtrls, FileCtrl, ActnList, Mask, CPortCtl,
  CPort, mmSystem, NEditKomponente, NStringGridKomponente, Menus;


Const MAXLINZAHL_I = 60;


type
  str255     = String[255];

  teinstellung = (paramBlz, paramMesszahl, paramB_rs232, paramP_rs232,
                  paramNullabgleich, paramSpektrGlaetten,
                  paramDBPfad, paramDBName, paramDBMethode,
                  paramRegHoehe, paramRegBreite, paramRegDef, paramRegOffset,
                  paramChromGlaetten,
                  paramOffsetWieviele, paramOffsetDist,
                  paramAErkMinHoehe, paramAErkMehrere, paramAErkLinie,
                  paramGrenzkorrektur,
                  paramEStandardDLine,               //Externer Standard
                  paramOLinie, paramOKorrektLinie,   //Basislinenkorrektur
                  paramDriftKLinie, paramDriftGlGrad);

  tdatenbankparameter = Record
                          primaersignal_s : String;
                        End;

  teinzellin = Object //Enthlt alle Informationen zur Messung einer Linie
                 ccd_i                  : Integer; //auf welcher CCD-Zeile die
                                                   //Linie ist
                 von_i, bis_i           : Integer; //der Bereich, auf dem die
                                                   //Linie gemessen wird
                 blankvon_i, blankbis_i : Integer; //der Bereich, auf dem der
                                                   //Nullableich gemessen wird
                 Function konvertieren(zeile_i       : Integer;
                                       linienanzeige : TNStringGrid) : Boolean;
                 Procedure senden;
               End;


  TEinstForm = class(TForm)
    OK: TBitBtn;
    abbrechen: TBitBtn;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PageControl: TPageControl;
    LinTabSheet: TTabSheet;
    loeschen: TBitBtn;
    SpektrometerTabSheet: TTabSheet;
    Panel1: TPanel;
    BlzLabel: TLabel;
    MesszahlLabel: TLabel;
    b_rs232Label: TLabel;
    p_rs232Label: TLabel;
    NullabgleichLabel: TLabel;
    SpGlaettungLabel: TLabel;
    NullabgleichPanel: TPanel;
    JaRadioButton: TRadioButton;
    NeinRadioButton: TRadioButton;
    SpGlaettungPanel: TPanel;
    SpEinsRadioButton: TRadioButton;
    SpDreiRadioButton: TRadioButton;
    SpFuenfRadioButton: TRadioButton;
    SpAlleRadioButton: TRadioButton;
    BaudComComboBox: TComComboBox;
    ComPort: TComPort;
    PortComComboBox: TComComboBox;
    SpekNullRegLabel: TLabel;
    BlzNEdit: TNEdit;
    MesszahlNEdit: TNEdit;
    SpekNull2PNEdit: TNEdit;
    LinienNStringGrid: TNStringGrid;
    ChromTabSheet: TTabSheet;
    VorschauPanel: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    ZeitVorschauNEdit: TNEdit;
    IntVorschauNEdit: TNEdit;
    ChromGlaettungPanel: TPanel;
    ChromGlaettungLabel: TLabel;
    ChromGaettungPanel: TPanel;
    DreiRadioButton: TRadioButton;
    FuenfRadioButton: TRadioButton;
    SiebenRadioButton: TRadioButton;
    PopupMenu: TPopupMenu;
    SignalerkennungMenueItem: TMenuItem;
    SignalTabSheet: TTabSheet;
    Panel2: TPanel;
    OffsetWievieleLabel: TLabel;
    OffsetDistLabel: TLabel;
    OffsetWievieleNEdit: TNEdit;
    OffsetDistNEdit: TNEdit;
    Panel4: TPanel;
    NullRegLabel: TLabel;
    Null2PNEdit: TNEdit;
    Panel3: TPanel;
    Label2: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    AErkennungNEdit: TNEdit;
    Panel5: TPanel;
    ErkennungJaRadioButton: TRadioButton;
    ErkennungNeinRadioButton: TRadioButton;
    AErkennungWelcheNEdit: TNEdit;
    Panel6: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    OffsetLinieNEdit: TNEdit;
    OffsetKorrektLinieNEdit: TNEdit;
    Label11: TLabel;
    Label5: TLabel;
    Label12: TLabel;
    OffsetKorrektLinieMenueItem: TMenuItem;
    OffsetLinieMenueItem: TMenuItem;
    Panel7: TPanel;
    Label13: TLabel;
    Label14: TLabel;
    DriftKLinieNEdit: TNEdit;
    Label15: TLabel;
    Panel9: TPanel;
    NeunRadioButton: TRadioButton;
    ElfRadioButton: TRadioButton;
    DZehnRadioButton: TRadioButton;
    Label19: TLabel;
    Label20: TLabel;
    MethodenTabSheet: TTabSheet;
    MethodenPanel: TPanel;
    NeueMethodeEdit: TEdit;
    NeueMethodeLabel: TLabel;
    MethodenNameLabel: TLabel;
    MethodenLabel: TLabel;
    MethodenMemo: TMemo;
    Label1: TLabel;
    MethodenComboBox: TComboBox;
    LoeschenBitBtn: TBitBtn;
    NeuBitBtn: TBitBtn;
    Panel10: TPanel;
    Label21: TLabel;
    Label22: TLabel;
    EStandardNEdit: TNEdit;
    EStandardMenueItem: TMenuItem;
    MethodenFileListBox: TFileListBox;
    Label17: TLabel;
    GrenzkorrekturNEdit: TNEdit;
    procedure FormCreate(Sender: TObject);
    Procedure konvertieren;
    procedure loeschenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SignalerkennungMenueItemClick(Sender: TObject);
    procedure LinienNStringGridMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure LinienNStringGridDblClick(Sender: TObject);
    procedure OffsetKorrektLinieMenueItemClick(Sender: TObject);
    procedure OffsetLinieMenueItemClick(Sender: TObject);
    procedure NeuBitBtnClick(Sender: TObject);
    procedure LoeschenBitBtnClick(Sender: TObject);
    procedure EStandardMenueItemClick(Sender: TObject);
    procedure MethodenComboBoxChange(Sender: TObject);
    procedure LinienNStringGridRowMoved(Sender: TObject; FromIndex,
      ToIndex: Integer);

  private
    { Private-Deklarationen }
    Me1400               : TMe1400;
    linien               : Array[1..MAXLINZAHL_I] Of teinzellin;
    arbeitsverzeichnis_s : String; //Standardarbeitsverzeichnis um laden und
                                   //und Speichern der Methoden = Stamm-
                                   //verzeichnis von Spektrograph
    //lpf_s                : String; //Linienpfad
    lz_i                 : Integer;
    CCDZahl_i            : Integer;
    AktMethode_s         : String;

    Function zum_spektrometer(neustart_b : Boolean) : Boolean;

    Function  spglaettungsgrad_i : Integer;
    Procedure standardeinstellungen;

    Procedure MethodenNameAktualisieren(AktMethVonPlatte_b : Boolean);
    Function MethodeLaden_b : Boolean;
    Function MethodeSpeichern_b(pfad_s : String) : Boolean;
    //Function linladen(suchpfad_s : str255) : Boolean;
    //Function lin_speichern_b(suchpfad_s : String) : Boolean;

  public { Public-Deklarationen }

     Property lz_i_Prop : Integer Read lz_i;

     Function ShowModal : Integer; Override;

     Procedure InLinien(bez_s, von_s, bis_s    : String;
                        blankvon_s, blankbis_s : String);
                        //aus dem Kalibrationsvorgang am Spektrum
                        //Liniendaten bernehmen

     Function OutLinDat_s(linie_i : Integer) : String;
     Function OutLinBez_s(linie_i : Integer) : String;
     //Function OutLinPfad_s                   : String;

     Function OutChromGlaettung_i : Integer;

     Function OutNull2pZahl_i : Integer;
     //Nullabgleich durch eine Gerade, die durch zwei Punkte kurz vor und nach
     //dem Signal luft. OutNull2pZahl_i ist die Anzahl der Punkte vor und nach
     //dem Signal, die zur Mittelung herangezogen werden.

     Function OutEinst_s(WelcheEinstellung : teinstellung) : String;
     //gibt die gewnschte Einstellung als String aus.

     Function SpektrometerBenachrichtigen_b(command : tcommand) : Boolean;

     Function DoppelterStart_b : Boolean;

  end;

var
  EinstForm: TEinstForm;

implementation

{$R *.DFM}



Function tEinstForm.ShowModal : Integer;
Begin
  Result := Inherited ShowModal;
  If Result = mrOK Then
     Begin
       MethodeSpeichern_b(Arbeitsverzeichnis_s + '\' + AktMethode_s + '.MTH');
       konvertieren
     End
     Else
     Begin
       MethodeLaden_b;
       konvertieren
     End;
  If Not(zum_spektrometer(False)) Then
     If Not(DoppelterStart_b) Then
          Begin
            MessageBeep(MB_ICONSTOP);
            MessageDlg('Keine Kommunikation mit dem Spektrometer mglich!',
                       mtError, [mbOK], 0)
          End;
End;



Function tEinstForm.OutChromGlaettung_i : Integer;
Begin
  If DreiRadioButton.Checked Then Result := 3
     Else If FuenfRadioButton.Checked Then Result := 5
          Else Result := 7
End;



Function tEinstForm.spglaettungsgrad_i : Integer;
Begin
  If SpEinsRadioButton.Checked Then Result := 1
     Else If SpDreiRadioButton.Checked Then Result := 3
          Else If SpFuenfRadioButton.Checked Then Result := 5
          Else Result := 7
End;



Function tEinstForm.OutNull2PZahl_i : Integer;
Begin
  Result := Null2PNEdit.IntRead_i
End;



Function tEinstForm.OutEinst_s(WelcheEinstellung : teinstellung) : String;
Begin
  Case WelcheEinstellung Of
       paramBlz            : Result := blzNEdit.StrRead_s;
       paramMesszahl       : Result := MesszahlNEdit.StrRead_s;
       paramB_rs232        : Result := BaudComComboBox.Text;
       paramP_rs232        : Result := PortComComboBox.Text;
       paramNullabgleich   : If jaRadioButton.Checked Then Result := 'Ja'
                                Else Result := 'Nein';
       paramSpektrGlaetten : If SpEinsRadioButton.Checked Then
                                Result := 'Nein'
                                Else If SpDreiRadioButton.Checked Then
                                        Result := 'Ja, ber 3 Punkte'
                                        Else If SpFuenfRadioButton.Checked Then
                                                Result := 'Ja, ber 5 Punkte'
                                                Else Result:='Ja, Mittelwert';
       paramOffsetWieviele : Result := OffsetWievieleNEdit.StrRead_s;
       paramOffsetDist     : Result := OffsetDistNEdit.    StrRead_s;
       paramAErkMinHoehe   : Result := AErkennungNEdit.    StrRead_s;
       paramAErkMehrere    : If ErkennungJaRadioButton.Checked Then
                                Result := 'Ja'
                                Else Result := 'Nein';
       paramAErkLinie      : Result := AErkennungWelcheNEdit.StrRead_s;
       paramGrenzkorrektur : Result := GrenzkorrekturNEdit.StrRead_s;
       paramEStandardDLine : Result := EStandardNEdit.StrRead_s;
       paramOLinie         : Result := OffsetLinieNEdit.StrRead_s;
       paramOKorrektLinie  : Result := OffsetKorrektLinieNEdit.StrRead_s;
       paramDriftKLinie    : Result := DriftKLinieNEdit.StrRead_s;
       paramDriftGlGrad    : If NeunRadioButton.Checked Then
                                Result := '9'
                                Else If ElfRadioButton.Checked Then
                                        Result := '11'
                                        Else Result:='13';
     End
End;



Function tEinstForm.OutLinDat_s(linie_i : Integer) : String;
Begin
  Result := LinienNStringGrid.ZeileAuslesen_s(linie_i, 0, 5)
End;



Function tEinstForm.OutLinBez_s(linie_i : Integer) : String;
Begin
  Result := LinienNStringGrid.StrRead_s(1, linie_i)
End;



{Function TEinstForm.OutLinPfad_s : String;
Begin
  Result := LPF_s;
End;        }



Procedure teinzellin.senden;  //Sendet die Linieninformationen ber die RS232

Var puffer_si : SmallInt;

Begin
  With EinstForm Do
       Begin
         puffer_si := ccd_i;
         ComPort.Write(puffer_si, 2);
         puffer_si := von_i;
         ComPort.Write(puffer_si, 2);
         puffer_si := bis_i;
         ComPort.Write(puffer_si, 2);
         puffer_si := blankvon_i;
         ComPort.Write(puffer_si, 2);
         puffer_si := blankbis_i;
         ComPort.Write(puffer_si, 2)
       End
End;




Function teinzellin.konvertieren(zeile_i       : Integer;
                                 linienanzeige : TNStringGrid) : Boolean;

Const PIXELZAHL = 2100;

Begin
  With linienanzeige Do
       Begin
         ExecStatus_b_Prop; //..wird zurckgesetzt
         von_i      := IntRead_i(2, zeile_i);
         bis_i      := IntRead_i(3, zeile_i);
         blankvon_i := IntRead_i(4, zeile_i);
         blankbis_i := IntRead_i(5, Zeile_i);
         Result     := ExecStatus_b_Prop
       End;

  If Result Then
     Begin
       ccd_i  := 1; //Es wird auf die Pixelzahl der betreffenden CCD umge-
                    //rechnet
       While (von_i > PIXELZAHL) And Not(ccd_i = 5) Do
             Begin
               Dec(von_i,      PIXELZAHL);
               Dec(bis_i,      PIXELZAHL);
               Dec(blankvon_i, PIXELZAHL);
               Dec(blankbis_i, PIXELZAHL);
               Inc(ccd_i)
             End;

       If ccd_i = 5 Then Result := False; //Fehler, weil ein Wert grer 8400
                                          //eingegeben wurde

       If von_i < 5 Then Result := False; //Keine Pixel mehr fr die
                                          //SG-Glttung (5 = Reserve wegen
                                          //Glaettung)

       If blankvon_i < 5             Then Result := False;//Fehler, weil nicht
       If von_i      > PIXELZAHL - 5 Then Result := False;//alle Pixel auf der
       If bis_i      > PIXELZAHL - 5 Then Result := False;//selben CCD sind;
       If blankvon_i > PIXELZAHL - 5 Then Result := False;//-5: Reserve wegen
       If blankbis_i > PIXELZAHL - 5 Then Result := False;//Glttung


       If von_i      > bis_i      Then Result := False;//Fehler, weil
       If blankvon_i > blankbis_i Then Result := False;//von und bis vertauscht

       If (von_i >= blankvon_i) Then                    //Fehler,
          If (von_i <= blankbis_i) Then Result := False;//weil sich
       If (bis_i >= blankvon_i) Then                    //blank- und
          If (bis_i <= blankbis_i) Then Result := False;//Integra-
       If (von_i <  blankvon_i) Then                    //tionsbe-
          If (bis_i >  blankbis_i) Then Result := False;//reich berlappen
       If (blankvon_i <  von_i) Then
          If (blankbis_i >  bis_i) Then Result := False;

     End
End;




{Function tEinstForm.linladen(suchpfad_s : str255) : Boolean;

Var datei_txt : TextFile;
    i, j      : Integer;
    dummy_s   : String;

begin
  If suchpfad_s = '' Then Result := False
     Else
     Begin
       Try AssignFile(datei_txt, suchpfad_s);
           Reset(datei_txt);
           Result := True;
       Except Result := False;
       End;
       If Result Then
          Begin
            Try For i := 1 To MAXLINZAHL_I Do
                    For j := 1 To 5 Do
                        Begin
                          ReadLn(datei_txt, dummy_s);
                          LinienNStringGrid.StrWrite(j, i, dummy_s)
                        End;
            Except Result := False;
            End;
            Try CloseFile(datei_txt);
            Except Result := False
            End
          End;
     End;

     IF Result Then
        Begin
          lpf_s := suchpfad_s;
          konvertieren          //Konvertierung des Stringgrids in Zahlen-
                                //werte der zu vermessenden Linien
        End
        Else
          Begin
            Application.MessageBox('Fehler beim Laden der Linieninformationen!',
                                   'Fehlermeldung', Mb_Ok + MB_ICONSTOP);
            With LinienNStringGrid Do
                 Begin
                   ClearAll;
                   For i := 1 To RowCount Do IntWrite(0, i, i)
                 End;
            Result := False
          End
End; }



Procedure TEinstForm.standardeinstellungen;
Begin
  BlzNEdit.Startwert_e_Prop            := 200;
  MesszahlNEdit.Startwert_e_Prop       := 1;
  Null2PNEdit.Startwert_e_Prop         := 1;
  SpekNull2PNEdit.Startwert_e_Prop     := 1;
  BaudComCombobox.text                 := 'Custom';
  PortComCombobox.text                 := 'COM2';
  NeinRadioButton.Checked              := True;
  JaRadioButton.Checked                := False;
  DreiRadioButton.Checked              := True;
  SiebenRadioButton.Checked            := False;
  NeunRadioButton.Checked              := False;
  ElfRadioButton.Checked               := True;
  DZehnRadioButton.Checked             := False;
  //lpf_s                                := '';
  ComPort.BaudRate                     := StrToBaudrate(BaudComComboBox.Text);
  ComPort.Port                         := PortComCombobox.text;
  OffsetWievieleNEdit.Startwert_e_Prop := 1;
  OffsetDistNEdit.Startwert_e_Prop     := 1;
  AErkennungNEdit.Startwert_e_Prop     := 30;
  ErkennungJaRadioButton.Checked       := False;
  ErkennungNeinRadioButton.Checked     := True;
End;



Function tEinstForm.MethodeLaden_b : Boolean;

Var datei_txt   : TextFile;
    i, j        : Integer;
    puffer_s    : String;
    glaettung_i : Integer;

Begin
  Try AssignFile(datei_txt, arbeitsverzeichnis_s + '\' + Aktmethode_s + '.MTH');
      Reset(datei_txt);
      Result := True;
  Except Result := False;
         End;
  If Not(Result) Then
     Begin
       MessageBeep(MB_ICONSTOP);
       MessageDlg('Methodendatei konnte nicht geffnet werden!',
                  mtError, [mbOK], 0                            );
     End
     Else
     Begin
       Try ReadLn(datei_txt, puffer_s);
           BaudComComboBox.ItemIndex := StrToInt(puffer_s);
           ReadLn(datei_txt, puffer_s);
           PortComComboBox.Text := puffer_s;
           //Keine Manipulationen an der RS232, falls das Programm schon einmal
           //gestartet wurde
           If DoppelterStart_b Then
              Begin
                BaudComComboBox.AutoApply := False;
                PortComComboBox.AutoApply := False;
              End
              Else
              Begin
                BaudComComboBox.AutoApply := True;
                PortComComboBox.AutoApply := True;
                With ComPort Do
                     Begin
                       Port := PortComComboBox.Text;
                       BaudRate := StrToBaudrate(BaudComComboBox.Text);
                     End;
              End;

           ReadLn(datei_txt);
           ReadLn(datei_txt, puffer_s);
           IntVorschauNEdit.Text := puffer_s;
           ReadLn(datei_txt, puffer_s);
           ZeitVorschauNEdit.Text := puffer_s;
           ReadLn(datei_txt, puffer_s);
           BlzNEdit.Text := puffer_s;
           ReadLn(datei_txt, puffer_s);
           MesszahlNEdit.Text := puffer_s;
           ReadLn(datei_txt, puffer_s);
           JaRadioButton.Checked := (puffer_s = 'TRUE');
           If Not(JaRadioButton.Checked) Then
              NeinRadioButton.Checked := True;
           ReadLn(datei_txt, glaettung_i);
           DreiRadioButton.Checked   := False;
           FuenfRadioButton.Checked  := False;
           SiebenRadioButton.Checked := False;
           Case glaettung_i Of
                3 : DreiRadioButton.Checked   := True;
                5 : FuenfRadioButton.Checked  := True;
                7 : SiebenRadioButton.Checked := True
              End;
           ReadLn(datei_txt, glaettung_i);
           SpEinsRadioButton.Checked  := False;
           SpDreiRadioButton.Checked  := False;
           SpFuenfRadioButton.Checked := False;
           SpAlleRadioButton.Checked  := False;
           Case glaettung_i Of
                1 : SpEinsRadioButton.Checked  := True;
                3 : SpDreiRadioButton.Checked  := True;
                5 : SpFuenfRadioButton.Checked := True;
                7 : SpAlleRadioButton.Checked  := True
              End;
           ReadLn(datei_txt, puffer_s);
           SpekNull2PNEdit.Text := puffer_s;
           ReadLn(datei_txt, puffer_s);
           Null2PNEdit.Text := puffer_s;
           ReadLn(datei_txt, puffer_s);
           OffsetWievieleNEdit.Text := puffer_s;
           ReadLn(datei_txt, puffer_s);
           OffsetDistNEdit.Text := puffer_s;
           ReadLn(datei_txt, puffer_s);
           AErkennungNEdit.Text := puffer_s;
           ReadLn(datei_txt, puffer_s);
           If puffer_s = 'TRUE' Then
              Begin
                ErkennungJaRadioButton.Checked   := True;
                ErkennungNeinRadioButton.Checked := False
              End
              Else
              Begin
                ErkennungJaRadioButton.Checked   := False;
                ErkennungNeinRadioButton.Checked := True
              End;
           Readln(datei_txt, puffer_s);
           AErkennungWelcheNEdit.Text := Puffer_s;

           Readln(datei_txt, puffer_s);
           EStandardNEdit.Text := puffer_s;
           Readln(datei_txt, puffer_s);
           GrenzkorrekturNEdit.Text := puffer_s;
           Readln(datei_txt, puffer_s);
           OffsetLinieNEdit.Text := puffer_s;
           Readln(datei_txt, puffer_s);
           OffsetKorrektLinieNEdit.Text := puffer_s;
           Readln(datei_txt, puffer_s);
           DriftKLinieNEdit.Text := puffer_s;
           Readln(datei_txt, glaettung_i);
           NeunRadioButton.Checked  := False;
           ElfRadioButton.Checked   := False;
           DZehnRadioButton.Checked := False;
           Case glaettung_i Of
                9  : NeunRadioButton.Checked  := True;
                11 : ElfRadioButton.Checked   := True;
                13 : DZehnRadioButton.Checked := True
              End;
           For i := 1 To MAXLINZAHL_I Do
               For j := 1 To 5 Do
                   Begin
                     ReadLn(datei_txt, puffer_s);
                     LinienNStringGrid.StrWrite(j, i, puffer_s);
                   End;
           MethodenMemo.Lines.Clear;
           While Not(EOF(datei_txt)) Do
                 Begin
                   ReadLn(datei_txt, puffer_s);
                   MethodenMemo.Lines.Add(puffer_s);
                 End;
       Except Result := False;
              End;
       Try CloseFile(datei_txt)
       Except Result := False
              End;
       If Not(Result) Then
          Begin
            MessageBeep(MB_ICONSTOP);
            MessageDlg('Methodendatei konnte nicht geladen werden!',
                       mtError, [mbOK], 0                          );
            standardeinstellungen
          End
     End;
End;



Function tEinstForm.MethodeSpeichern_b(pfad_s : String) : Boolean;

Var datei_txt : TextFile;
    i, j      : Integer;

Begin
  Result := Not(AktMethode_s = '');
  If Result Then
     Begin
       Try AssignFile(datei_txt, pfad_s);
           ReWrite(datei_txt);
           Result := True;
       Except Result := False;
              End;
     End;

  If Not(Result) Then
     Begin
       MessageBeep(MB_ICONSTOP);
       MessageDlg('Methodendatei konnte nicht geffnet werden!',
                  mtError, [mbOK], 0                            );
     End
     Else
     Begin
       Try WriteLn(datei_txt, BaudComComboBox.ItemIndex);
           WriteLn(datei_txt, PortComComboBox.Text);
           WriteLn(datei_txt);
           WriteLn(datei_txt, IntVorschauNEdit.StrRead_s);
           WriteLn(datei_txt, ZeitVorschauNEdit.StrRead_s);
           WriteLn(datei_txt, BlzNEdit.StrRead_s);
           WriteLn(datei_txt, MesszahlNEdit.Text);
           WriteLn(datei_txt, JaRadioButton.Checked);
           If DreiRadioButton.Checked Then WriteLn(datei_txt, '3')
              Else If FuenfRadioButton.Checked Then WriteLn(datei_txt, '5')
                      Else WriteLn(datei_txt, '7');
           WriteLn(datei_txt, spglaettungsgrad_i);
           WriteLn(datei_txt, SpekNull2PNEdit.StrRead_s);
           WriteLn(datei_txt, Null2PNEdit.StrRead_s);
           WriteLn(datei_txt, OffsetWievieleNEdit.StrRead_s);
           WriteLn(datei_txt, OffsetDistNEdit.StrRead_s);
           WriteLn(datei_txt, AErkennungNEdit.StrRead_s);
           WriteLn(datei_txt, ErkennungJaRadioButton.Checked);
           WriteLn(datei_txt, AErkennungWelcheNEdit.StrRead_s);
           WriteLn(datei_txt, EStandardNEdit.StrRead_s);
           WriteLn(datei_txt, GrenzkorrekturNEdit.StrRead_s);
           WriteLn(datei_txt, OffsetLinieNEdit       .StrRead_s);
           WriteLn(datei_txt, OffsetKorrektLinieNEdit.StrRead_s);
           WriteLn(datei_txt, DriftKLinieNEdit.StrRead_s);
           If NeunRadioButton.Checked Then WriteLn(datei_txt, '9')
              Else If ElfRadioButton.Checked Then WriteLn(datei_txt, '11')
                      Else WriteLn(datei_txt, '13');
           For i := 1 To MAXLINZAHL_I Do
               For j := 1 To 5 Do
                   WriteLn(datei_txt, LinienNStringGrid.StrRead_s(j, i));
           For i := 0 To Pred(MethodenMemo.Lines.Count) Do
               WriteLn(datei_txt, MethodenMemo.Lines.Strings[i]);
       Except Result := False;
              End;
       Try CloseFile(datei_txt);
           Except Result := False
           End;
     End;
  If Not(Result) Then
     Begin
       MessageBeep(MB_ICONSTOP);
       MessageDlg('Methodendatei konnte nicht gespeichert werden!',
                  mtError, [mbOK], 0                               );
     End;
End;



Function tEinstForm.zum_spektrometer(neustart_b : Boolean) : Boolean;

Var blz_i        : Integer;
    messzahl_i   : Integer;
    b_rs232_i    : Integer;
    i            : Integer;
    puffer_smi   : SmallInt;
    commando_by  : Byte;
    timerid_i    : Integer;

Begin
  blz_i := BlzNEdit.IntRead_i;
  If Not(Me1400 = Nil)                 And
     Not(Me1400.SchonGestartet_b_prop) And
     Me1400.timer_io_ok_b              Then
     Begin
       If neustart_b Then Me1400.io_richtung_setzen;
       Me1400.belichtungszeit_setzen(blz_i);
       If Me1400.SendCommand_b(coParameter, ComPort) Then
          Begin  //Dem Spektrometer wird die Anweisung ber die Timer/Counter-
                                                         //IO-Karte bermilltel
            puffer_smi := lz_i;
            ComPort.Write(puffer_smi, 2);
            For i := 1 To lz_i Do linien[i].senden;
            puffer_smi := spglaettungsgrad_i;
            ComPort.Write(puffer_smi, 2);
            puffer_smi := MesszahlNEdit.IntRead_i;
            ComPort.Write(puffer_smi, 2);
            puffer_smi := SpekNull2PNEdit.IntRead_i;
            ComPort.Write(puffer_smi, 2);
            If JaRadioButton.Checked Then
               Begin
                 puffer_smi := 0;
                 ComPort.Write(puffer_smi, 2)
               End
               Else
               Begin
                 puffer_smi := 1;
                 ComPort.Write(puffer_smi, 2)
               End;
            Result := True
          End
          Else Result := False;
       Result := Me1400.SendCommand_b(coLeerlauf, ComPort)
     End
     Else Result := False
End;



procedure TEinstForm.FormCreate(Sender: TObject);

Var i         : Integer;

begin
  lz_i                   := 0;
  ComPort.CustomBaudRate := 9600;
  GetDir(0, arbeitsverzeichnis_s);
  MethodenFileListBox.Mask := arbeitsverzeichnis_s + '\*.MTH';
  MethodenNameAktualisieren(True);
  MethodeLaden_b;

  konvertieren;
  With LinienNStringGrid Do
       Begin
         StrWrite(1, 0, 'Bezeichung');
         StrWrite(2, 0, 'Von');
         StrWrite(3, 0, 'Bis');
         StrWrite(4, 0, 'Null-von');
         StrWrite(5, 0, 'Null-bis');
         For i := 1 To MAXLINZAHL_I Do Cells[0, i] := IntToStr(i)
       End;

  Try Me1400 := TMe1400.Create;
  Except
    Application.MessageBox('Schwerwiegender Initalisierungsfehler!',
                           'Fehlermeldung', Mb_Ok + MB_ICONSTOP);
  End;

  If Not(zum_spektrometer(True)) Then
     If Not(DoppelterStart_b) Then
          Begin
            MessageBeep(MB_ICONSTOP);
            MessageDlg('Keine Kommunikation mit dem Spektrometer mglich!',
                       mtError, [mbOK], 0)
          End;
end;



procedure TEinstForm.FormDestroy(Sender: TObject);
begin
  Me1400.Free
end;



Procedure TEinstForm.konvertieren;

Var konv_ok_b   : Boolean;

Begin
  lz_i      := 0;       //Gltigkeitsberprfung des Stringgitterinhaltes
  konv_ok_b := True;    //von "lininenanzeige" und Konvetierung desselben und...
  While Not(lz_i = Succ(MAXLINZAHL_I))                       And
        konv_ok_b                                            And
        Not(LinienNStringGrid.StrRead_s(1, Succ(lz_i)) = '') Do
        Begin
          Inc(lz_i);   //...Bestimmung der Anzahl der zu messenden Linien
          konv_ok_b := linien[lz_i].konvertieren(lz_i, LinienNStringGrid)
        End;

  If Not(konv_ok_b) Then   //Falls nicht alle Zellen gltige Inhalte besitzen
     Begin                 //wird eine Fehlermelung ausgegeben
       Dec(lz_i);
       Application.
           MessageBox(PChar('Linieneinstellungen: Eingabefehler in Zeile '
                             + IntToStr(lz_i) + '!'),
                      'Fehlermeldung', Mb_Ok + MB_ICONSTOP)
     End
End;



{Function TEinstForm.lin_speichern_b(suchpfad_s : String) : Boolean;

Var datei_txt   : TextFile;
    i, j        : Integer;

Begin
  Try AssignFile(datei_txt, suchpfad_s);
      Rewrite(datei_txt);
      Result := True;
  Except Result := False;
  End;
  If Result Then
     Begin
       Try For i := 1 To MAXLINZAHL_I Do
               For j := 1 To 5 Do
                   WriteLn(datei_txt, LinienNStringGrid.StrRead_s(j, i));
       Except Result := False;
       End;
       Try CloseFile(datei_txt);
       Except Result := False
       End
     End;

  IF Result Then lpf_s := suchpfad_s
     Else
     Application.MessageBox('Speichern der Linien fehlgeschlagen!',
                            'Fehlermeldung', Mb_Ok + MB_ICONSTOP)
End;  }



Procedure TEinstForm.InLinien(bez_s, von_s, bis_s    : String;
                              blankvon_s, blankbis_s : String);

Var wohin_i : Integer;

Begin
  wohin_i := 0;
  With LinienNStringGrid Do
       Begin
         While Not(Cells[1,Succ(wohin_i)]='') And Not(wohin_i = MAXLINZAHL_I) Do
               Inc(wohin_i);
         Inc(wohin_i);
         If Not(wohin_i = Succ(MAXLINZAHL_I)) Then
            Begin
              StrWrite(1, wohin_i, bez_s);
              StrWrite(2, wohin_i, von_s);
              StrWrite(3, wohin_i, bis_s);
              StrWrite(4, wohin_i, blankvon_s);
              StrWrite(5, wohin_i, blankbis_s)
            End;
       End;
End;



procedure TEinstForm.loeschenClick(Sender: TObject);

Var i : Integer;

begin
  With LinienNStringGrid Do
       Begin
         ClearRow(Row);
         For i := 1 To RowCount Do IntWrite(0, i, i)
       End
end;



Function TEinstForm.SpektrometerBenachrichtigen_b(command : tcommand) : Boolean;
Begin
  If Not(Me1400 = Nil)                              And
     Not(Me1400.SchonGestartet_b_prop)              And
     Me1400.timer_io_ok_b                           And
     Me1400.SendCommand_b(Command, ComPort) Then
     Result := True
     Else Result := False
End;



Function TEinstForm.DoppelterStart_b : Boolean;
Begin
  If Me1400 = Nil Then Result := False
     Else Result := Me1400.SchonGestartet_b_Prop;
End;



procedure TEinstForm.SignalerkennungMenueItemClick(Sender: TObject);
begin
  AErkennungWelcheNEdit.Text := IntToStr(LinienNStringGrid.Row)
end;



procedure TEinstForm.LinienNStringGridMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  With Mouse.CursorPos Do
       If Button = mbRight Then PopupMenu.Popup(X, Y);
end;



procedure TEinstForm.LinienNStringGridDblClick(Sender: TObject);
begin
  With Mouse.CursorPos Do PopupMenu.Popup(X, Y);
end;



procedure TEinstForm.OffsetKorrektLinieMenueItemClick(Sender: TObject);
begin
  OffsetKorrektLinieNEdit.Text := IntToStr(LinienNStringGrid.Row)
end;



procedure TEinstForm.OffsetLinieMenueItemClick(Sender: TObject);
begin
  OffsetLinieNEdit.Text := IntToStr(LinienNStringGrid.Row)
end;



procedure TEinstForm.EStandardMenueItemClick(Sender: TObject);
begin
  EStandardNEdit.Text := IntToStr(LinienNStringGrid.Row)
end;


    
procedure TEinstForm.LoeschenBitBtnClick(Sender: TObject);
begin
  MessageBeep(MB_ICONEXCLAMATION);
  If MessageDlg('Die Methode wird entgltig gelscht!',
                mtWarning, mbOKCancel, 0               ) = mrOK Then
     If DeleteFile(ArbeitsVerzeichnis_s + '\' + AktMethode_s + '.MTH') Then
        MethodenNameAktualisieren(False)
        Else
        Begin
          MessageBeep(MB_ICONSTOP);
          MessageDlg('Die Methode konnte nicht entfernt werden!',
                     mtError, [mbCancel], 0                       )
        End;
end;



procedure TEinstForm.NeuBitBtnClick(Sender: TObject);
begin
  If ((AktMethode_s = '') OR MethodeSpeichern_b(  Arbeitsverzeichnis_s
                                                + '\' + AktMethode_s
                                                + '.MTH')                 ) And
     MethodeSpeichern_b(  ArbeitsVerzeichnis_s + '\'
                        + NeueMethodeEdit.Text + '.MTH')                    Then
     AktMethode_s := NeueMethodeEdit.Text;
  MethodenNameAktualisieren(False);
end;



Procedure TEinstForm.MethodenNameAktualisieren(AktMethVonPlatte_b : Boolean);

Var i        : Integer;
    puffer_s : String;

Function GewaehltenEintragLaden_b : Boolean;

Var puffer_s  : String;
    i         : Integer;
    datei_txt : TextFile;

Begin
  Try AssignFile(datei_txt, Arbeitsverzeichnis_s + '\AMethName.SPG');
      Reset(datei_txt);
      Result := True;
  Except Result := False;
  End;
  Try Read(datei_txt, AktMethode_s);
      Except Result := False
      End;
  Try CloseFile(datei_txt);
      Except Result := False
      End;
  IF Not(Result) Then
     Begin
       Application.MessageBox('Fehler beim Laden der aktuellen Methode! ' +
                              'Probleme beim Laden von "AMethName.SPG"!',
                              'Fehlermeldung', Mb_Ok + MB_ICONSTOP);
       AktMethode_s := ''
     End
End;

Function GewaehltenEintragSpeichern_b : Boolean;

Var Datei_txt : TextFile;

Begin
  Try AssignFile(datei_txt, Arbeitsverzeichnis_s + '\AMethName.SPG');
      Rewrite(datei_txt);
      Result := True;
  Except Result := False;
  End;
  Write(datei_txt, MethodenComboBox.Items.Strings[MethodenComboBox.ItemIndex]);
  Try CloseFile(datei_txt);
       Except Result := False
       End;
  IF Not(Result) Then
     Application.MessageBox('Fehler beim Speichern der Methode! ' +
                            'Probleme beim Speichern von "AMethName.SPG"!',
                            'Fehlermeldung', Mb_Ok + MB_ICONSTOP)
End;

Begin
  If AktMethVonPlatte_b Then GewaehltenEintragLaden_b;
  With MethodenFileListBox Do
       Begin
         Update;
         MethodenComboBox.Clear;
         MethodenComboBox.ItemIndex := -1;
         For i := 0 To Pred(Items.Count) Do
             Begin
               puffer_s := Items.Strings[i];
               //Endung wegnehemen
               If Copy(puffer_s, Length(puffer_s) - 3, 4) = '.MTH' Then
                  puffer_s := Copy(puffer_s, 1, Length(puffer_s) - 4);
               //Eintrag hinzufgen
               MethodenComboBox.Items.Add(puffer_s)
             End;
         For i := 0 To Pred(MethodenComboBox.Items.Count) Do
             If MethodenComboBox.Items.Strings[i] = AktMethode_s Then
                MethodenComboBox.ItemIndex := i;
         If MethodenComboBox.ItemIndex = -1 Then AktMethode_s := ''
       End;
  GewaehltenEintragSpeichern_b;
End;



procedure TEinstForm.MethodenComboBoxChange(Sender: TObject);
begin
  If Not(AktMethode_s = '') Then
     MethodeSpeichern_b(Arbeitsverzeichnis_s + '\' + AktMethode_s + '.MTH');
  AktMethode_s := MethodenComboBox.Text;
  If Not(MethodeLaden_b) Then AktMethode_s := '';
  MethodenNameAktualisieren(False)
end;




procedure TEinstForm.LinienNStringGridRowMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);

Var i : Integer;

begin
  For i := 1 To MAXLINZAHL_I Do LinienNStringGrid.Cells[0, i] := IntToStr(i)
end;




end.
