unit ImportFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, NEditKomponente;

type
  TImportForm = class(TForm)
    BitBtn1: TBitBtn;
    BlzLabel: TLabel;
    MesszahlLabel: TLabel;
    NullabgleichLabel: TLabel;
    NullabgleichPanel: TPanel;
    JaRadioButton: TRadioButton;
    NeinRadioButton: TRadioButton;
    SpGlaettungPanel: TPanel;
    SpEinsRadioButton: TRadioButton;
    SpDreiRadioButton: TRadioButton;
    SpFuenfRadioButton: TRadioButton;
    SpAlleRadioButton: TRadioButton;
    SpGlaettungLabel: TLabel;
    BlzNEdit: TNEdit;
    MesszahlNEdit: TNEdit;
    InfoStaticText: TStaticText;
    NormierungLabel: TLabel;
    NormiertPanel: TPanel;
    NormJaRadioButton: TRadioButton;
    NormNeinRadioButton: TRadioButton;
    ChromGlaettungLabel: TLabel;
    ChromGaettungPanel: TPanel;
    DreiRadioButton: TRadioButton;
    FuenfRadioButton: TRadioButton;
    SiebenRadioButton: TRadioButton;
    KGRadioButton: TRadioButton;
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Procedure ModalZeigen(Var belichtungszeit_s : String;
                          Var MessZahl_s        : String;
                          Var NullAbgl_s        : String;
                          Var SpektrGlaettung_s : String;
                          Var History_s         : String);
  end;

var
  ImportForm: TImportForm;

implementation

{$R *.DFM}




procedure TImportForm.FormCreate(Sender: TObject);
begin
  JaRadioButton.      Checked := False;
  NeinRadioButton.    Checked := True;
  SpEinsRadioButton.  Checked := True;
  SpDreiRadioButton.  Checked := False;
  SpFuenfRadioButton. Checked := False;
  SpAlleRadioButton.  Checked := False;
  NormJaRadioButton.  Checked := False;
  NormNeinRadioButton.Checked := True;
  KGRadioButton.      Checked := True;
  DreiRadioButton.    Checked := False;
  FuenfRadioButton.   Checked := False;
  SiebenRadioButton.  Checked := False;
end;


Procedure TImportForm.ModalZeigen(Var belichtungszeit_s : String;
                                  Var MessZahl_s        : String;
                                  Var NullAbgl_s        : String;
                                  Var SpektrGlaettung_s : String;
                                  Var History_s         : String);

Const HISTORY_SEP = '|';

Var ChromGlaettungsgrad_i : Integer;

Begin
  ShowModal;
  Belichtungszeit_s := 'Belichtungszeit:;'     + BlzNEdit.StrRead_s;
  MessZahl_s        := 'Anzahl an Messungen:;' + MesszahlNEdit.StrRead_s;

  If jaRadioButton.Checked Then NullAbgl_s := 'Nullabgleich im Spektrum:;Ja'
                           Else NullAbgl_s := 'Nullabgleich im Spektrum:;Nein';

  If SpEinsRadioButton.Checked Then
     SpektrGlaettung_s := 'Glttung im Spektrum:;Nein'
     Else
     If SpDreiRadioButton.Checked Then
        SpektrGlaettung_s := 'Glttung im Spektrum:;Ja, ber 3 Punkte'
        Else
        If SpFuenfRadioButton.Checked Then
           SpektrGlaettung_s := 'Glttung im Spektrum:;Ja, ber 5 Punkte'
           Else
           SpektrGlaettung_s := 'Glttung im Spektrum:;Ja, Mittelwert';

  IF KGRadioButton.Checked then ChromGlaettungsgrad_i := 0
     Else
     If DreiRadioButton.Checked Then ChromGlaettungsgrad_i := 3
        Else
        If FuenfRadioButton.Checked Then ChromGlaettungsgrad_i := 5
           Else
           If SiebenRadioButton.Checked Then ChromGlaettungsgrad_i := 7;
  If Not(ChromGlaettungsgrad_i = 0) Then
     history_s :=   history_s
                  + 'Gltten('
                  + IntToStr(ChromGlaettungsgrad_i)
                  + ')'
                  + HISTORY_SEP;
  If NormJaRadioButton.Checked Then History_s :=   History_s
                                                 + 'Normierung'
                                                 + HISTORY_SEP
                                                 + DateToStr(Date)
                                                 + HISTORY_SEP
                                                 + TimeToStr(Time)
                                                 + HISTORY_SEP
                                                 + DateToStr(Date)
                                                 + HISTORY_SEP
                                                 + TimeToStr(Time)
                                                 + HISTORY_SEP;
End;


end.
