unit SichtbareLinienFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, NStringGridKomponente, StdCtrls, Buttons, Einstellungsformular;

type
  TVisLines_a_b = Array[0..Pred(MAXLINZAHL_I)] Of Boolean;

  TSichtbareLinienForm = class(TForm)
    LinienNStringGrid: TNStringGrid;
    OKBitBtn: TBitBtn;
    AbbrechenBitBtn: TBitBtn;
    procedure LinienNStringGridDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }

    Function ShowModal(Var VisibleLines_a_b : TVisLines_a_b;
                           LinNamen_s       : String       ) : Integer;Overload;
  end;

var
  SichtbareLinienForm: TSichtbareLinienForm;

implementation



{$R *.DFM}

procedure TSichtbareLinienForm.LinienNStringGridDblClick(Sender: TObject);
begin
    With LinienNStringGrid Do
       If StrRead_s(2, Row) = 'Nein' Then Cells[2, Row] := 'Ja'
                                     Else Cells[2, Row] := 'Nein'
end;



procedure TSichtbareLinienForm.FormCreate(Sender: TObject);

Var i : Integer;

begin
  With LinienNStringGrid Do
       Begin
         StrWrite(0, 0, 'Nr.');
         StrWrite(1, 0, 'Signal');
         StrWrite(2, 0, 'Anzeigen?')
       End
end;




Function TSichtbareLinienForm.
         ShowModal(Var VisibleLines_a_b : TVisLines_a_b;
                       LinNamen_s       : String       ) : Integer;

Const Trennzeichen = ';';

Var i, j : Integer;

Begin
  With LinienNStringGrid Do
       Begin
         RowCount := 2;
         j := 1;
         StrWrite(1, j, '');
         For i := 1 To Length(LinNamen_s) Do
             If LinNamen_s[i] = TRENNZEICHEN Then
                Begin
                  Inc(j);
                  RowCount := Succ(j);
                  StrWrite(1, j, '')
                End
                Else StrWrite(1, j, StrRead_s(1, j) + LinNamen_s[i]);

         For i := 1 To Pred(RowCount) Do
             Begin
               StrWrite(0, i, IntToStr(i));
               If VisibleLines_a_b[Pred(i)] Then StrWrite(2, i, 'Ja')
                                            Else StrWrite(2, i, 'Nein');
             End
       End;
  If ShowModal = mrOK Then
     With LinienNStringGrid Do
          For i := 1 To Pred(RowCount) Do
              VisibleLines_a_b[Pred(i)] := (StrRead_s(2, i) = 'Ja')
End;




end.
