unit Zuordnungsformular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, SignaleKlasse;

type
  tVerwSubst = Record  // Alle Substanzen, die sich derzeit in der Datenbank
                    namen_da_s : Array Of String;                 //befinden
                    pfade_da_s : Array Of String
                  End;

  TZuordnungForm = class(TForm)
    SubstanzenStringGrid: TStringGrid;
    FuerAlleCheckBox: TCheckBox;
    ErklaerungLabel: TLabel;
    Label1: TLabel;
    SignalLabel: TLabel;
    SignalEdit: TEdit;
    OKBitBtn: TBitBtn;
    AbbruchBitBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Function ModalAnzeigen(    welches_i   : Integer;
                               Signale     : TSignale;
                               VerwSubst   : TVerwSubst;
                           Var SubstPfad_s : String) : TModalResult;
  end;

var
  ZuordnungForm: TZuordnungForm;

implementation

{$R *.DFM}

procedure TZuordnungForm.FormCreate(Sender: TObject);
begin
  SubstanzenStringGrid.RowCount := 2;
  SubstanzenStringGrid.Cells[0, 0]
                                 := 'Bitte hier die gewnschte Substanz whlen:'
end;



Function TZuordnungForm.ModalAnzeigen(    welches_i   : Integer;
                                          Signale     : TSignale;
                                          VerwSubst   : TVerwSubst;
                                      Var SubstPfad_s : String) : TModalResult;

Var i : Integer;

Begin
  FuerAlleCheckBox.Checked := False;
  SignalEdit.Text := Signale.HistoryStringArray.StrRead_s(0, welches_i);
  With SubstanzenStringGrid, VerwSubst Do
       Begin
         RowCount := 2;
         Cells[0, 1] := namen_da_s[0];
         For i := 3 To High(namen_da_s) + 2 Do
             Begin
               RowCount := i;
               Cells[0, Pred(i)] := namen_da_s[i - 2]
             End;
         Result := ShowModal;
         If Result = mrOK Then
            Begin
              SubstPfad_s := Pfade_da_s[Pred(Row)];
              If FuerAlleCheckBox.Checked Then Result := mrAll
            End
            Else SubstPfad_s := '';
         RowCount := 2
       End;

End;



end.
